Package: GetoptLong
Type: Package
Title: Parsing Command-Line Arguments
Version: 1.1.1
Date: 2026-04-08
Authors@R: person("Zuguang", "Gu", email = "guzuguang@suat-sz.edu.cn", role = c("aut", "cre"),
                  comment = c('ORCID'="0000-0002-7395-8709"))
Depends: R (>= 4.0.0)
Imports: rjson, GlobalOptions (>= 0.1.0), methods, crayon
Suggests: testthat (>= 1.0.0), knitr, markdown, rmarkdown
VignetteBuilder: knitr
Description: This is a command-line argument parser which wraps the 
    powerful Perl module Getopt::Long and with some adaptations for easier use
	in R.
URL: https://github.com/jokergoo/GetoptLong
SystemRequirements: Perl, Getopt::Long
License: MIT + file LICENSE
NeedsCompilation: no
Packaged: 2026-04-08 05:02:23 UTC; guz
Author: Zuguang Gu [aut, cre] (ORCID: <https://orcid.org/0000-0002-7395-8709>)
Maintainer: Zuguang Gu <guzuguang@suat-sz.edu.cn>
Repository: CRAN
Date/Publication: 2026-04-08 09:50:14 UTC
Built: R 4.5.2; ; 2026-04-08 22:26:35 UTC; unix

Package: GetoptLong
Type: Package
Title: Parsing Command-Line Arguments
Version: 1.1.1
Date: 2026-04-08
Authors@R: person("Zuguang", "Gu", email = "guzuguang@suat-sz.edu.cn", role = c("aut", "cre"),
                  comment = c('ORCID'="0000-0002-7395-8709"))
Depends: R (>= 4.0.0)
Imports: rjson, GlobalOptions (>= 0.1.0), methods, crayon
Suggests: testthat (>= 1.0.0), knitr, markdown, rmarkdown
VignetteBuilder: knitr
Description: This is a command-line argument parser which wraps the 
    powerful Perl module Getopt::Long and with some adaptations for easier use
	in R.
URL: https://github.com/jokergoo/GetoptLong
SystemRequirements: Perl, Getopt::Long
License: MIT + file LICENSE
NeedsCompilation: no
Packaged: 2026-04-08 05:02:23 UTC; guz
Author: Zuguang Gu [aut, cre] (ORCID: <https://orcid.org/0000-0002-7395-8709>)
Maintainer: Zuguang Gu <guzuguang@suat-sz.edu.cn>
Repository: CRAN
Date/Publication: 2026-04-08 09:50:14 UTC

This R package is a wrapper of perl module `Getopt::Long`. 
Basically, all Perl distributions contain `Getopt::Long` as a core module and 
`JSON` module is already included in this package. So minimal requirement
for you to use this package is you should have Perl to be installed.

## ----echo = FALSE, message = FALSE--------------------------------------------
library(knitr)
knitr::opts_chunk$set(
    error = FALSE,
    tidy  = FALSE,
    message = FALSE,
    comment = NA,
    fig.align = "center")
library(GetoptLong)

## ----echo = FALSE, out.width = "600px"----------------------------------------
include_graphics("workflow.png")

## ----simple, eval = FALSE-----------------------------------------------------
#  library(GetoptLong)
#  
#  cutoff = 0.05
#  GetoptLong(
#      "number=i", "Number of items.",
#      "cutoff=f", "Cutoff for filtering results.",
#      "verbose",  "Print message."
#  )

## ----echo = FALSE-------------------------------------------------------------
chunks <- knitr:::knit_code$get()
GetoptLong.options("__argv_str__" = "--help")
local({ eval(parse(text = chunks[["simple"]])) })
GetoptLong.options("__argv_str__" = NULL)

## ----echo = FALSE-------------------------------------------------------------
chunks <- knitr:::knit_code$get()
GetoptLong.options("__argv_str__" = "--help")
GetoptLong.options("help_style" = "two-column")
local({ eval(parse(text = chunks[["simple"]])) })
GetoptLong.options("__argv_str__" = NULL)
GetoptLong.options("help_style" = "one-column")

## ----template, eval = FALSE---------------------------------------------------
#  spec = "
#  This is an example of using template to specify options.
#  
#  Usage: Rscript foo.R [options]
#  
#  Options:
#    <number=i> Number of items.
#    <cutoff=f> Cutoff for filtering results.
#    <verbose> Print messages.
#  
#  Contact: name@address
#  "
#  
#  GetoptLong(spec, template_control = list(opt_width = 21))

## ----echo = FALSE-------------------------------------------------------------
chunks <- knitr:::knit_code$get()
GetoptLong.options("__argv_str__" = "--help")
local({ eval(parse(text = chunks[["template"]])) })
GetoptLong.options("__argv_str__" = NULL)

## ----print_var, eval = FALSE--------------------------------------------------
#  library(GetoptLong)
#  
#  cutoff = 0.05
#  GetoptLong(
#      "number=i{1,}", "Number of items.",
#      "cutoff=f", "Cutoff for filtering results.",
#      "param=s%", "Parameters specified by name=value pairs.",
#      "verbose",  "Print message."
#  )
#  
#  print(number)
#  print(cutoff)
#  print(param)
#  print(verbose)

## ----echo = FALSE-------------------------------------------------------------
chunks <- knitr:::knit_code$get()
GetoptLong.options("__argv_str__" = "--number 1 2 --param var1=a var2=b --verbose")
local({ eval(parse(text = chunks[["print_var"]])) })
GetoptLong.options("__argv_str__" = NULL)

## ----eval = FALSE-------------------------------------------------------------
#  verbose = TRUE
#  GetoptLong(
#      "verbose!",  "Print message."
#  )

## ----with_env, eval = FALSE---------------------------------------------------
#  opt = new.env()
#  
#  opt$cutoff = 0.05
#  GetoptLong(
#      "number=i@", "Number of items.",
#      "cutoff=f", "Cutoff for filtering results.",
#      "param=s%", "Parameters specified by name=value pairs.",
#      "verbose",  "Print message.",
#  
#      envir = opt
#  )
#  print(as.list(opt))

## ----echo = FALSE-------------------------------------------------------------
chunks <- knitr:::knit_code$get()
GetoptLong.options("__argv_str__" = "--number 1 2 --param var1=a var2=b --verbose")
local({ eval(parse(text = chunks[["with_env"]])) })
GetoptLong.options("__argv_str__" = NULL)

## ----multi_word, eval = FALSE-------------------------------------------------
#  # or a default can be set for `bar_value`
#  # bar_value = 2
#  GetoptLong(
#      "bar_value=i", "Some value."
#  )
#  print(bar_value)

## ----echo = FALSE-------------------------------------------------------------
chunks <- knitr:::knit_code$get()
GetoptLong.options("__argv_str__" = "--bar-value 1")
local({ eval(parse(text = chunks[["multi_word"]])) })
GetoptLong.options("__argv_str__" = NULL)

## ----multi_word_logical, eval = FALSE-----------------------------------------
#  GetoptLong(
#      "show_messages!", "Whether to show messages?"
#  )
#  print(show_messages)

## ----echo = FALSE-------------------------------------------------------------
chunks <- knitr:::knit_code$get()
GetoptLong.options("__argv_str__" = "--show-messages")
local({ eval(parse(text = chunks[["multi_word_logical"]])) })
GetoptLong.options("__argv_str__" = NULL)

## ----echo = FALSE-------------------------------------------------------------
chunks <- knitr:::knit_code$get()
GetoptLong.options("__argv_str__" = "--no-show-messages")
local({ eval(parse(text = chunks[["multi_word_logical"]])) })
GetoptLong.options("__argv_str__" = NULL)

## ----complex_example, eval = FALSE--------------------------------------------
#  GetoptLong(
#      "count=i",  paste("This is a count. This is a count. This is a count.",
#                        "This is a count.  This is a count. This is a count."),
#      "number=f", paste("This is a number. This is a number. This is a number.",
#                        "This is a number. This is a number. This is a number."),
#      "array=f@", paste("This is an array. This is an array. This is an array.",
#                        "This is an array. This is an array. This is an array."),
#      "hash=s%",  paste("This is a hash. This is a hash. This is a hash.",
#                        "This is a hash. This is a hash. This is a hash."),
#      "verbose!", "Whether show messages",
#      "flag",     "a non-sense option"
#  )

## ----echo = FALSE-------------------------------------------------------------
chunks <- knitr:::knit_code$get()
GetoptLong.options("__argv_str__" = "--help")
local({ eval(parse(text = chunks[["complex_example"]])) })
GetoptLong.options("__argv_str__" = NULL)

## ----echo = FALSE-------------------------------------------------------------
chunks <- knitr:::knit_code$get()
GetoptLong.options("__argv_str__" = "--help")
local({ count = 1
    number = 0.1
    array = c(1, 2)
    hash = list("foo" = "a", "bar" = "b")
    verbose = TRUE
    eval(parse(text = chunks[["complex_example"]])) 
})
GetoptLong.options("__argv_str__" = NULL)

## ----eval = FALSE-------------------------------------------------------------
#  GetoptLong.options(help_style = "two-column")
#  # specifying the defaults
#  GetoptLong{
#      ...
#  }

## ----echo = FALSE-------------------------------------------------------------
chunks <- knitr:::knit_code$get()
GetoptLong.options("__argv_str__" = "--help")
GetoptLong.options("help_style" = "two-column")
local({ count = 1
    number = 0.1
    array = c(1, 2)
    hash = list("foo" = "a", "bar" = "b")
    verbose = TRUE
    eval(parse(text = chunks[["complex_example"]])) 
})
GetoptLong.options("__argv_str__" = NULL)
GetoptLong.options("help_style" = "one-column")

## ----sub_opt, eval = FALSE----------------------------------------------------
#  foo = list(a = 1, b = 2)
#  GetoptLong(
#      "foo=i%", paste("This is foo. This is foo. This is foo. This is foo.",
#                      "This is foo. This is foo. This is foo. This is foo."),
#      "foo$name1", paste("name1 in foo. name1 in foo. name1 in foo. name1 in foo.",
#                         "name1 in foo. name1 in foo. name1 in foo. name1 in foo."),
#      "foo$name2", paste("name2 in foo. name2 in foo. name2 in foo. name2 in foo.",
#                         "name2 in foo. name2 in foo. name2 in foo. name2 in foo."),
#      "bar=s%", paste("This is bar. This is bar. This is bar. This is bar.",
#                      "This is bar. This is bar. This is bar. This is bar."),
#      "bar$name3", paste("name3 in bar. name3 in bar. name3 in bar. name3 in bar.",
#                         "name3 in bar. name3 in bar. name3 in bar. name3 in bar."),
#      "bar$name4", paste("name4 in bar. name4 in bar. name4 in bar. name4 in bar.",
#                         "name4 in bar. name4 in bar. name4 in bar. name4 in bar.")
#  )

## ----echo = FALSE-------------------------------------------------------------
chunks <- knitr:::knit_code$get()
GetoptLong.options("__argv_str__" = "--help")
local({ eval(parse(text = chunks[["sub_opt"]])) })
GetoptLong.options("__argv_str__" = NULL)

## ----eval = FALSE-------------------------------------------------------------
#  GetoptLong.options(help_style = "two-column")
#  GetoptLong{
#      ...
#  }

## ----echo = FALSE-------------------------------------------------------------
chunks <- knitr:::knit_code$get()
GetoptLong.options("__argv_str__" = "--help")
GetoptLong.options(help_style = "two-column")
local({ eval(parse(text = chunks[["sub_opt"]])) })
GetoptLong.options("__argv_str__" = NULL)
GetoptLong.options(help_style = "one-column")

## ----head_and_foot, eval = FALSE----------------------------------------------
#  GetoptLong(
#      help_head = "This is a demonstration of adding usage head and foot.",
#  
#      "number=i", "Number of items.",
#      "cutoff=f", "Cutoff for filtering results.",
#      "verbose",  "Print message.",
#  
#      help_foot = "Please contact name@address."
#  )

## ----echo = FALSE-------------------------------------------------------------
chunks <- knitr:::knit_code$get()
GetoptLong.options("__argv_str__" = "--help")
local({ eval(parse(text = chunks[["head_and_foot"]])) })
GetoptLong.options("__argv_str__" = NULL)

## ----grouped_options, eval = FALSE--------------------------------------------
#  count = 1
#  array = c(0.1, 0.2)
#  GetoptLong(
#      "--------", "Binary options:",
#      "verbose!", "Whether show messages",
#      "flag",     "a non-sense option",
#  
#      "-------", "Single-value options:",
#      "count=i",  paste("This is a count. This is a count. This is a count.",
#                        "This is a count.  This is a count. This is a count."),
#      "number=f", paste("This is a number. This is a number. This is a number.",
#                        "This is a number. This is a number. This is a number."),
#  
#      "--------", paste("Multiple-vlaue options: long text long text long text",
#                        " long text long text long text long text long text"),
#      "array=f@", paste("This is an array. This is an array. This is an array.",
#                        "This is an array. This is an array. This is an array."),
#      "hash=s%",  paste("This is a hash. This is a hash. This is a hash.",
#                        "This is a hash. This is a hash. This is a hash."),
#  
#      "-------", "Other options:"
#  )

## ----echo = FALSE-------------------------------------------------------------
chunks <- knitr:::knit_code$get()
GetoptLong.options("__argv_str__" = "--help")
local({ eval(parse(text = chunks[["grouped_options"]])) })
GetoptLong.options("__argv_str__" = NULL)

## ----eval = FALSE-------------------------------------------------------------
#  GetoptLong.options(help_style = "two-column")
#  GetoptLong{
#      ...
#  }

## ----echo = FALSE-------------------------------------------------------------
chunks <- knitr:::knit_code$get()
GetoptLong.options("__argv_str__" = "--help")
GetoptLong.options(help_style = "two-column")
local({ eval(parse(text = chunks[["grouped_options"]])) })
GetoptLong.options("__argv_str__" = NULL)
GetoptLong.options(help_style = "one-column")

## ----complex_template, eval = FALSE-------------------------------------------
#  GetoptLong("
#  This is a demonstration of using template as the option specification.
#  
#  Usage: Rscript foo.R [options]
#  
#  Binary options:
#    <verbose!> Whether show messages
#    <flag> A non-sense option
#  
#  Single-value options:
#    <count=i> This is a count. This is a count.
#    <number=f> This is a number. This is a number.
#  
#  Multiple-vlaue options:
#    <array=f@> This is an array. This is an array.
#    <hash=s%> This is a hash. This is a hash.
#  
#  Questions, please contact your.name@email
#  ", template_control = list(opt_width = c(verbose = 23, flag = 23,
#                                           count = 22, number = 22,
#                                           array = 30, hash = 30)
#  ))

## ----echo = FALSE-------------------------------------------------------------
chunks <- knitr:::knit_code$get()
GetoptLong.options("__argv_str__" = "--help")
local({ eval(parse(text = chunks[["complex_template"]])) })
GetoptLong.options("__argv_str__" = NULL)

## ----template_multi_line, eval = FALSE----------------------------------------
#  GetoptLong("
#  Usage: Rscript foo.R [options]
#  
#    <count=i{2,}> This is a count. This is a count. This is a count.
#                  This is a count. This is a count.
#    <number=f> This is a number. This is a number. This is a number.
#               This is a number. This is a number.
#  ")

## ----echo = FALSE-------------------------------------------------------------
chunks <- knitr:::knit_code$get()
GetoptLong.options("__argv_str__" = "--help")
local({ eval(parse(text = chunks[["template_multi_line"]])) })
GetoptLong.options("__argv_str__" = NULL)

## ----version, eval = FALSE----------------------------------------------------
#  VERSION = "0.0.1"
#  GetoptLong(
#      "tag=i", "...",
#  )

## ----version2, eval = FALSE---------------------------------------------------
#  VERSION = numeric_version("1.1-1")
#  GetoptLong(
#      "tag=i", "...",
#  )

## ----eval = FALSE-------------------------------------------------------------
#  GetoptLong.options("config" = "bundling")
#  GetoptLong.options("config" = c("no_ignore_case", "bundling"))

## ----eval = FALSE-------------------------------------------------------------
#  source_script("foo.R", argv_str = "--cutoff 0.01 --input file=foo.txt --verbose")

## ----eval = TRUE--------------------------------------------------------------
sessionInfo()

## ----echo = FALSE, results = "asis"-------------------------------------------
get_os <- function(){
  sysinf <- Sys.info()
  if (!is.null(sysinf)){
  os <- sysinf['sysname']
  if (os == 'Darwin')
    os <- "osx"
  } else { ## mystery machine
    os <- .Platform$OS.type
    if (grepl("^darwin", R.version$os))
      os <- "osx"
    if (grepl("linux-gnu", R.version$os))
      os <- "linux"
  }
  tolower(os)
}

is.solaris = function() {
  os = get_os()
  !(os %in% c("windows", "unix", "linux", "osx"))
}

if(is.solaris()) {
  cat("**GetoptLong** is not supported on Solaris platform.\n")
} else {
  if(!is.solaris()) {
      invisible(knit("GetoptLong.Rmd2", "GetoptLong.md2"))
  }

  if(Sys.info()["user"] == "jokergoo") {
      invisible(file.copy("GetoptLong.md2", "/Users/jokergoo/project/GetoptLong/vignettes/GetoptLong.md2", overwrite = TRUE))
  }

  ln = readLines("GetoptLong.md2")
  cat(paste(ln, collapse = "\n"))
}

## ----echo = FALSE, message = FALSE--------------------------------------------
library(knitr)
knitr::opts_chunk$set(
    tidy  = FALSE,
    comment = NA,
    fig.align = "center")
library(GetoptLong)

## ----main, eval = FALSE-------------------------------------------------------
#  library(GetoptLong)
#  
#  subCommands(
#  	"sub1", "sub1.R",
#  	        "This is the description of sub command 1, which will be a long long long text.",
#  	"sub2", "sub2.R",
#  	        "This is the description of sub command 2, which will be a long long long text."
#  )

## ----sub1, eval = FALSE-------------------------------------------------------
#  library(GetoptLong)
#  
#  GetoptLong("foo=i", "Set value for foo.")
#  
#  qqcat("foo is @{foo}\n")

## ----sub2, eval = FALSE-------------------------------------------------------
#  library(GetoptLong)
#  
#  GetoptLong("bar=i", "Set value for bar")
#  
#  qqcat("bar is @{bar}\n")

## ----echo = FALSE, eval = TRUE, results = "asis"------------------------------
chunks <- knitr:::knit_code$get()
writeLines(chunks[["main"]], con = "main.R")
writeLines(chunks[["sub1"]], con = "sub1.R")
writeLines(chunks[["sub2"]], con = "sub2.R")
cat("```\n")
cat(system("Rscript main.R", intern = TRUE), sep = "\n")
cat("```\n")

## ----echo = FALSE, eval = TRUE, results = "asis"------------------------------
cat("```\n")
cat(system("Rscript main.R sub1 --help", intern = TRUE), sep = "\n")
cat("```\n")

## ----echo = FALSE, eval = TRUE, results = "asis"------------------------------
cat("```\n")
cat(system("Rscript main.R sub1 --foo 10", intern = TRUE), sep = "\n")
cat("```\n")

## ----eval = FALSE-------------------------------------------------------------
#  subCommands(
#  	"sub1", "path/sub1.R", "description 1",
#  	"sub2", "path/sub2.R", "description 2"
#  )

## ----eval = FALSE-------------------------------------------------------------
#  subCommands(
#  	"path/sub1.R", "description 1",
#  	"path/sub2.R", "description 2"
#  )

## ----section, eval = FALSE----------------------------------------------------
#  subCommands(
#  	"----", "----", "This is section1",
#  	"sub1", "sub1.R",
#  	      "This is the description of sub command 1, which will be a long long long text.",
#  
#  	"----", "----", "This is section2",
#  	"sub2", "sub2.R",
#  	      "This is the description of sub command 2, which will be a long long long text."
#  )

## ----echo = FALSE, eval = TRUE, results = "asis"------------------------------
chunks <- knitr:::knit_code$get()
writeLines(c("library(GetoptLong)", chunks[["section"]]), con = "main.R")

cat("```\n")
cat(system("Rscript main.R", intern = TRUE), sep = "\n")
cat("```\n")

## ----head-foot, eval = FALSE--------------------------------------------------
#  subCommands(
#  	help_head = "This is the head of the help message.",
#  
#  	"sub1", "sub1.R",
#  	        "This is the description of sub command 1, which will be a long long long text.",
#  	"sub2", "sub2.R",
#  	        "This is the description of sub command 2, which will be a long long long text.",
#  
#  	help_foot = "This is the foot of the help message."
#  )

## ----echo = FALSE, eval = TRUE, results = "asis"------------------------------
chunks <- knitr:::knit_code$get()
writeLines(c("library(GetoptLong)", chunks[["head-foot"]]), con = "main.R")

cat("```\n")
cat(system("Rscript main.R", intern = TRUE), sep = "\n")
cat("```\n")

## ----template, eval = FALSE---------------------------------------------------
#  subCommands(
#  "This is the head of the help message.
#  
#  Usage: Rscript main.R [command] [options]
#  
#  Commands:
#    <sub1=sub1.R> This is the description of sub command 1, which will be a long long
#            long text.
#    <longlonglong=sub2.R> This is the description of sub command 2, which will be a long long
#            long text.
#  
#  This is the foot of the help message.
#  "
#  )

## ----echo = FALSE, eval = TRUE, results = "asis"------------------------------
chunks <- knitr:::knit_code$get()
writeLines(c("library(GetoptLong)", chunks[["template"]]), con = "main.R")

cat("```\n")
cat(system("Rscript main.R", intern = TRUE), sep = "\n")
cat("```\n")

## ----echo = FALSE, results = "hide"-------------------------------------------
file.remove("main.R")
file.remove("sub1.R")
file.remove("sub2.R")

# == title
# Simple variable interpolation in texts
#
# == param
# -...          Text string in which variables are marked with certain rules
# -envir        Environment where to look for variables. By default it is the environment
#               where `qq` is envoked. It can also be a list in which element names are
#               the variable names to be interpolated.
# -code.pattern Pattern of marks for the variables. By default it is ``@\\\\{CODE\\\\}`` which means
#               you can write your variable as ``@{variable}``. This value can be a vector that all 
#               patterns are searched.
# -collapse     If variables return vector of length larger than one, whether collapse into one string
#               or return a vector
# -sep          Separator character when there are multiple templates.
#
# == details
# I like variable interpolation in Perl. But in R, if you want to concatenate plain text and variables,
# you need to use functions such as `base::paste`. However, if there are so many variables, quotes, braces 
# in the string you want to construct, it would be painful.
#   
# This function allows you to construct strings as in Perl style. Variables are
# marked in the text with certain rule. `qq` will look up these variables in user's
# environment and replace the variable marks with their real values.
#
# For more explaination of this function, please refer to vignette.
#
# == author
# Zuguang Gu <z.gu@dkfz.de>
#
# == example
# a = 1
# b = "text"
# qq("a = @{a}, b = '@{b}'")
# qq("a = @{a}", "b = '@{b}'", sep = ", ")
#
# a = 1:2
# qq("a = @{a}, b = '@{b}'")
# qq("a = @{a}, b = '@{b}'", collapse = FALSE)
#
# a = 1
# qq("a = `a`, b = '`b`'", code.pattern = "`CODE`")
#
qq = function(..., envir = parent.frame(), code.pattern = NULL, collapse = TRUE, sep = " ") {

	lt = list(...)

	if(length(lt) == 1) {
		text = lt[[1]]
	} else {
		text = paste(unlist(lt), collapse = sep)
	}
	
	if(is.null(code.pattern)) {
		if(!is.null(options("code.pattern")[[1]])) {
			code.pattern = options("code.pattern")[[1]]
		} else {
			code.pattern = qq.options("code.pattern")
		}
	}
	
    if(length(text) != 1) {
        stop("Now only support text with length of 1.\n")
    }
	
    if(!is.null(envir)) {
		if(is.environment(envir)) {
			e = envir
		} else {
			e = as.environment(envir)
		}
    } else {
        e = .GlobalEnv
    }
	
#    for (i in 1:length(text)) {
 
        # check wether there are code replacements
    	template = NULL
    	code = NULL
    	for(i in seq_along(code.pattern)) {
	        fc = find_code(code.pattern[i], text)
	        template = c(template, fc[[1]])
	        code = c(code, fc[[2]])
	    }
 
        if(length(template)) {   # if there is code replacement
           
            # replace the code with its value
            return_value = lapply(code, function(c) {
				x = eval(parse(text = c), envir = e)
                if(is.null(x)) {
                    return("")
				} else if(length(x) == 0) {
					return("")
				} else {
					if(is.factor(x)) {
						x = as.vector(x)
					}
					return(x)
				}
			})  # anony function is the first level parent
			
			is_return_value_vector = sapply(return_value, function(r) is.atomic(r))
			if(! all(is_return_value_vector)) {
				stop("All your codes should only return simple atomic vectors.\n")
			}
			
            # length of the return value
            # need to test it since not all code returns a scalar
            return_value_length = sapply(return_value, function(x) length(x))
 
            if(max(return_value_length) > 1) {
            # if some piece of codes return a vector
            # recycle to `max(return_value_length)`
                current = rep(text, max(return_value_length))
                
                for(ai in 1:max(return_value_length)) {
                    for(iv in 1:length(template)) {
                        current[ai] = gsub(template[iv],
                                           return_value[[iv]][(ai-1) %% length(return_value[[iv]]) + 1],
                                           current[ai], fixed = TRUE)
                    }
                }
                
				if(collapse) {
					text = paste(current, collapse = "")
				} else {
					text = current
				}
                
            } else if(max(return_value_length == 1)) {   # all variable returns a scalar
            
                current = text
                
                for(iv in 1:length(template)) {
                    current = gsub(template[iv], return_value[[iv]], current, fixed = TRUE)
                }
                
                text = current
                
            }
        }
#    }
 	
	return(text)
}
 
find_code = function(m, text) {
 
    if(length(text) != 1) {
        stop("text must be length of 1.")
    }
 
    m2 = gsub("CODE", ".+?", m)
 
    reg = gregexpr(m2, text)[[1]]
    v1 = character(0)
    if(reg[1] > -1) {
        v1 = sapply(1:length(reg), function(i) substr(text, as.numeric(reg)[i], as.numeric(reg)[i]+ attr(reg, "match.length")[i] - 1))
    }
    edge = strsplit(m, "CODE")[[1]]
    v2 = gsub(paste("^", edge[1], "|", edge[2], "$", sep=""), "", v1)
    
    return(list(template=v1, code=v2))
}


# == title
# Print a string which has been intepolated with variables
#
# == param
# -...         text string in which variables are marked with certain rules
# -envir          environment where to look for those variables
# -code.pattern pattern of marks for the variables
# -file        pass to `base::cat`
# -sep         pass to `base::cat`
# -fill        pass to `base::cat`
# -labels      pass to `base::cat`
# -append      pass to `base::cat`
# -cat_prefix  prefix string. It is prior than ``qq.options(cat_prefix)``.
# -strwrap     whether call `base::strwrap` to wrap the string
# -strwrap_param parameters sent to `base::strwrap`, must be a list
# -sep2          Separation character when there are multiple templates.
#
# == details
# This function is a shortcut of
#
#     cat(qq(text, envir, code.pattern), ...)
#
# Additionally, you can add global prefix:
#
#     qq.options("cat_prefix" = "[INFO] ")
#     qq.options("cat_prefix" = function(x) format(Sys.time(), "[\%Y-\%m-\%d \%H:\%M:\%S] "))
#     qq.options("cat_prefix" = NULL)
#
# You can also add local prefix by specifying ``cat_prefix`` in `qqcat`.
#
#     qqcat(text, cat_prefix = "[INFO] ")
#
# Please refer to `qq` to find more details.
#
# == author
# Zuguang Gu <z.gu@dkfz.de>
#
# == example
# a = 1
# b = "text"
# qqcat("a = @{a}, b = '@{b}'\n")
# qqcat("a = `a`, b = '`b`'\n", code.pattern = "`CODE`")
#
# qq.options("cat_prefix" = function(x) format(Sys.time(), "[\%Y-\%m-\%d \%H:\%M:\%S] "))
# qqcat("a = @{a}, b = '@{b}'\n")
# Sys.sleep(2)
# qqcat("a = @{a}, b = '@{b}'\n")
# qq.options(RESET = TRUE)
qqcat = function(..., envir = parent.frame(), code.pattern = NULL, file = "",
    sep = " ", fill = FALSE, labels = NULL, append = FALSE, cat_prefix = NULL,
    strwrap = qq.options("cat_strwrap"), strwrap_param = list(), sep2 = "") {

	lt = list(...)
	if(length(lt) == 1) {
		text = lt[[1]]
	} else {
		text = paste(unlist(lt), collapse = sep2)
	}

	text = qq(text, envir = envir, code.pattern = code.pattern)
	if(strwrap) {
		if(!inherits(strwrap_param, "list")) {
			stop("`strwrap_param` must be a list.")
		}
		if(grepl("\n$", text)) {
			text = paste(do.call("strwrap", c(strwrap_param, list(x = text))), collapse = "\n")
			text = paste0(text, "\n")
		} else {
			text = paste(do.call("strwrap", c(strwrap_param, list(x = text))), collapse = "\n")
		}
		
	}
	cat(text, file = file, sep = sep, fill = fill, labels = labels, append = append, cat_prefix = cat_prefix)
}

cat = function(..., file = "", sep = " ", fill = FALSE, labels = NULL, append = FALSE, cat_prefix = NULL) {
    
	if(!is.null(options("cat_verbose")[[1]])) {
		if(!options("cat_verbose")[[1]]) {
			return(invisible(NULL))
		}
	}
	
	if(!qq.options("cat_verbose")) {
		return(invisible(NULL))
	}
	
	if(is.null(cat_prefix)) {
		if(!is.null(options("cat_prefix")[[1]])) {
			cat_prefix = options("cat_prefix")[[1]]
		} else {
			cat_prefix = qq.options("cat_prefix")
		}		
	}
    
	if(is.function(cat_prefix)) {
		cat_prefix = cat_prefix()
	}
	
    base::cat(cat_prefix, file = file, sep = sep, fill = fill, labels = labels, append = append)
    base::cat(... , file = file, sep = sep, fill = fill, labels = labels, append = append)
}

# == title
# Setting sub commands
#
# == param
# -...     Specification of commands. See section Details.
# -help_head Head of the help message when invoking ``Rscript foo.R``.
# -help_foot Foot of the help message when invoking ``Rscript foo.R``.
# -argv_str A string that contains command-line arguments. It is only for testing purpose.
#
# == details
# The format of input can be one of the following:
#
# 1. A matrix with two columns. Then the first column contains paths of the scripts and the second column contains the description of the subcommand. The basenames of path in the first column
#    by removing the suffix are taken as the sub commands.
# 2. A matrix with three columns. The the first column contains the sub commands, the second column contains corresponding script paths and the third column contains descriptions of the sub commands.
# 3. A vector with length as multiples of 2. In this case, every two elements are grouped and concatenated into a matrix by rows. Then it follows the rule 1.
# 4. A vector with length as multiples of 3. In this case, every three elements are grouped and concatenated into a matrix by rows. Then it follows the rule 2.
#
subCommands = function(..., help_head = NULL, help_foot = NULL, argv_str = NULL) {

	if(is.null(get_scriptname())) {
		IS_UNDER_COMMAND_LINE = FALSE
	} else {
		IS_UNDER_COMMAND_LINE = TRUE
	}

	if(is.null(argv_str)) {
		argv_str = GetoptLong.options("__argv_str__")
	}
	on.exit(GetoptLong.options("__argv_str__" = NULL))

	# to test whether the script is run under command-line or in R interactive environment
	if(IS_UNDER_COMMAND_LINE || is.null(argv_str)) {
		OUT = stderr()
	} else {
		OUT = stdout()  # message from STDOUT is important under testing mode
	}

	############### parse specification ##################

	spec = list(...)

	# a vector or a two-column/three-column matrix
	if(length(spec) == 1) {
		spec = spec[[1]]
	} else {
		spec = unlist(spec)
	}

	template = NULL
	if(is.matrix(spec)) {
		if(ncol(spec) == 2) {
			l_opt_group = grepl("^[-=\\+#%]*$", spec[, 1])
			if(!all(file.exists(spec[!l_opt_group, 1]))) {
				stop_wrap("The specification is set as a two-column matrix. The first column should be paths of the scripts.")
			}
			spec = cbind(gsub("\\.\\w+$", "", basename(spec)), spec)
		} else if(ncol(spec) == 3 ) {
			l_opt_group = grepl("^[-=\\+#%]*$", spec[, 1])
			if(!all(file.exists(spec[!l_opt_group, 2]))) {
				stop_wrap("The specification is set as a three-column matrix. The second column should be paths of the scripts.")
			}
		} else {
			stop_wrap("If the specification is a matrix, it should be a two-column or three-column matrix.")
		}
		colnames(spec) = c("command", "script", "description")

	} else {
		if(is.vector(spec)) {
			if(length(spec) %% 6 == 0) {
				# test whether it is two-column setting or three-column
				l = seq_along(spec) %% 2 == 1
				spec2 = cbind(command = basename(spec[l]), script = spec[l], description = spec[!l])
				l_opt_group = grepl("^[-=\\+#%]*$", spec2[, 1])
				if(all(file.exists(spec2[!l_opt_group, 2]))) {
					spec = spec2
				} else {
					ind = seq_along(spec) %% 3 == 2
					spec2 = cbind(command = gsub("\\.\\w+$", "", basename(spec[seq_along(spec) %% 3 == 1])), script = spec[seq_along(spec) %% 3 == 2], description = spec[seq_along(spec) %% 3 == 0])
					l_opt_group = grepl("^[-=\\+#%]*$", spec2[, 1])
					if(all(file.exists(spec2[!l_opt_group, 2]))) {
						spec = spec2
					} else {
						stop_wrap(qq("The specification is set as a vector of length @{length(spec)}. If it is a multiple of 2, elements with indices 1,3,... should be paths of the script, and if the length is a multiple of 3, elements with indices 1,4,7,... should be command names and elements with indices 2,5,8,... should be paths of the corresponding scripts."))
					}
				}
				
			} else if(length(spec) %% 2 == 0) {
				l = seq_along(spec) %% 2 == 1
				spec = cbind(command = basename(spec[l]), script = spec[l], description = spec[!l])
				l_opt_group = grepl("^[-=\\+#%]*$", spec[, 1])
				if(!all(file.exists(spec[!l_opt_group, 2]))) {
					stop_wrap(qq("The specification is set as a vector of length @{length(spec)}. Elements with indices 1,3,... should be paths of the script."))
				}
			} else if(length(spec) %% 3 == 0) {
				ind = seq_along(spec) %% 3 == 2
				spec = cbind(command = gsub("\\.\\w+$", "", basename(spec[seq_along(spec) %% 3 == 1])), script = spec[seq_along(spec) %% 3 == 2], description = spec[seq_along(spec) %% 3 == 0])
				l_opt_group = grepl("^[-=\\+#%]*$", spec[, 1])
				if(!all(file.exists(spec[!l_opt_group, 2]))) {
					stop_wrap(qq("The specification is set as a vector of length @{length(spec)}. Elements with indices 1,4,7,... should be command names and elements with indices 2,5,8,... should be paths of the corresponding scripts."))
				}
			} else if(length(spec) == 1) {
				# template
				template = spec[1]
				code = find_code(GetoptLong.options("template_tag"), template)$code
				lt = strsplit(code, "=")
				lt = lapply(lt, function(x) if(length(x) == 1) c(gsub("\\.\\w+$", "", x), x) else x)
				spec = do.call(rbind, lt)
				colnames(spec) = c("command", "script")
				spec = cbind(spec, description = rep("foo", nrow(spec)))
				if(!all(file.exists(spec[, 2]))) {
					stop_wrap(qq("Some of the sripts do not exist."))
				}

			} else {
				stop_wrap(qq("The specification is set as a vector. The length of it must be multiples of 2 or 3. If the length is 1, then it is treated as a template."))
			}
		} else {
			stop_wrap("Wrong specification.")
		}
	}
	
	### opt groups
	l_opt_group = grepl("^[-=\\+#%]*$", spec[, 1])
	if(any(l_opt_group)) {
		i_group = 0
		opt_group = list()
		opt_group_desc = NULL
		if(!l_opt_group[1]) {
			opt_group[[1]] = numeric(0)
			opt_group_desc = ""
			i_group = 1
		}
		for(i in seq_along(l_opt_group)) {
			if(l_opt_group[i]) {
				i_group = i_group + 1
				opt_group[[i_group]] = numeric(0)
				opt_group_desc = c(opt_group_desc, spec[i, 3])
			} else {
				opt_group[[i_group]] = c(opt_group[[i_group]], i)
			}
		}
	} else {
		opt_group = list(1:nrow(spec))
		opt_group_desc = "Commands:"
	}

	if(!is.null(template)) {
		l_opt_group = rep(FALSE, nrow(spec))
	}

	all_commands = spec[!l_opt_group, 1]

	script_name = get_scriptname()
    if(is.null(script_name)) {
    	script_name = "foo.R"
    } else {
    	script_name = basename(script_name)
    }

	if(is.null(argv_str)) {
		ARGV = commandArgs(TRUE)
	} else {
		ARGV = strsplit(argv_str, "\\s+")[[1]]
	}

	if(length(ARGV) == 0) {
		print_help_msg_sub_commands(spec, file = stdout(), script_name = script_name, head = help_head, foot = help_foot, 
			opt_group = opt_group, opt_group_desc = opt_group_desc, template = template)
		if(IS_UNDER_COMMAND_LINE) {
			q(save = "no", status = 0)
		} else if(!is.null(argv_str)) {  # under test
			return(invisible(NULL))
		} else {
			stop("You have an error.\n")
		}
	}

	cmd = ARGV[1]
	ARGV_string = paste(ARGV[-1], collapse = " ")

	if(grepl("^-", cmd)) {
		cat(red(qq("Error: a command should be specified.\n")), file = OUT)

		print_help_msg_sub_commands(spec, file = stdout(), script_name = script_name, head = help_head, foot = help_foot, 
			opt_group = opt_group, opt_group_desc = opt_group_desc, template = template)
		if(IS_UNDER_COMMAND_LINE) {
			q(save = "no", status = 0)
		} else if(!is.null(argv_str)) {  # under test
			return(invisible(NULL))
		} else {
			stop("You have an error.\n")
		}
	}

	if(!cmd %in% all_commands) {
		cat(red(qq("Error: wrong command: @{cmd}.\n")), file = OUT)

		print_help_msg_sub_commands(spec, file = OUT, script_name = script_name, head = help_head, foot = help_foot, 
			opt_group = opt_group, opt_group_desc = opt_group_desc, template = template)
		if(IS_UNDER_COMMAND_LINE) {
			q(save = "no", status = 0)
		} else if(!is.null(argv_str)) {  # under test
			return(invisible(NULL))
		} else {
			stop("You have an error.\n")
		}
	}

	script = spec[spec[, 1] == cmd, 2]
	GetoptLong.options("__prefix__" = paste0("Rscript ", script_name, " ", cmd))
	on.exit(GetoptLong.options("__prefix__" = NULL))

	source_script(script, argv_str = ARGV_string)
}


print_help_msg_sub_commands = function(spec, file = stderr(), script_name = NULL, head = NULL, foot = NULL,
	opt_group = NULL, opt_group_desc = NULL, template = NULL) {

	if(is.null(template)) {
		if(is.null(script_name)) {
	    	script_name = get_scriptname()
		    if(is.null(script_name)) {
		    	script_name = "foo.R"
		    } else {
		    	script_name = basename(script_name)
		    }
		}
		if(!is.null(head)) {
			cat(format_text(head, prefix = NULL), file = file)
			cat("\n", file = file)
			cat("\n", file = file)
		}

	    qqcat("Usage: Rscript @{script_name} [command] [options]\n", file = file)
	    qqcat("\n", file = file)

	    for(ig in seq_along(opt_group)) {

	    	ind = opt_group[[ig]]

	    	if(!grepl("^\\s*$", opt_group_desc[ig])) {
		    	qqcat("@{format_text(opt_group_desc[ig], prefix = NULL)}\n", file = file)
		    }
		    
		    opt_width = max(nchar(spec[ind, 1]))
		    prefix = strrep(" ", opt_width + 6)
			for(i in ind) {
				cat("  ", spec[i, 1], strrep(" ", opt_width - nchar(spec[i, 1])), "    ", file = file, sep = "")
				desc = strwrap(spec[i, 3], width = 0.9*GetoptLong.options$help_width - opt_width - 6)
				if(length(desc) > 1) {
					desc[-1] = paste0(prefix, desc[-1])
				}
				cat(paste(desc, collapse = "\n"), file = file)
				cat("\n", file = file)
			}

			cat("\n", file = file)
			
		}

		if(!is.null(foot)) {
			cat(format_text(foot, prefix = NULL), file = file)
			cat("\n", file = file)
		}
	} else {
		lines = strsplit(template, "\n")[[1]]
		lines2 = NULL
		for(i in seq_along(lines)) {
			if(i == 1) {
				lines2[i] = lines[i]
			} else {
				if(grepl("^\\s{6,}\\w", lines[i], perl = TRUE)) {
					lines2[length(lines2)] = paste0(lines2[length(lines2)], " ",
						gsub("^\\s+", "", lines[i]))
				} else {
					lines2 = c(lines2, lines[i])
				}
			}
		}
		lines = lines2

		lt_parsed = lapply(lines, function(x) {
			res = find_code(GetoptLong.options("template_tag"), x)
			spec = res$code
			spec = strsplit(spec, "=")
			res$cmd = sapply(spec, function(s) {
				if(length(s) == 1) {
					cmd = gsub("\\.\\w+$", "", s)
				} else {
					cmd = s[1]
				}
				cmd
			})
			res
		})

		all_cmd = unique(unlist(lapply(lt_parsed, function(x) {
			x$cmd
		})))

		max_cmd_width = max(nchar(all_cmd))

		for(i in seq_along(lines)) {
			lt = lt_parsed[[i]]
			if(length(lt$template) == 0) {
				cat(paste(lines[i], collapse  = "\n"), "\n", file = file)
				next
			}

			prefix = strrep(" ", max_cmd_width + 6)
			for(j in seq_along(lt$template)) {
				cmd = lt$cmd[j]
				desc = gsub(lt$template[[j]], cmd, lines[[i]], fixed = TRUE)
				desc = gsub("^\\s+", "", desc)

				cmd2 = paste0("  ", cmd, strrep(" ", max_cmd_width - nchar(cmd)))
				cat(cmd2, "    ", file = file, sep = "")
				
				desc = strwrap(desc, width = 0.9*GetoptLong.options$help_width - max_cmd_width - 6)
				if(length(desc) > 1) {
					desc[-1] = paste0(prefix, desc[-1])
				}

				cat(paste(desc, collapse = "\n"), file = file)
				cat("\n", file = file)
			}
		}
	}
}

print_help_msg = function(opt_lt, file = stderr(), script_name = NULL, head = NULL, foot = NULL,
	template = NULL, template_control = NULL, style = c("one-column", "two-column"),
	opt_group = NULL, opt_group_desc = NULL) {

	if(is.null(template)) {
	
		if(is.null(script_name)) {
	    	script_name = get_scriptname()
		    if(is.null(script_name)) {
		    	script_name = "foo.R"
		    } else {
		    	script_name = basename(script_name)
		    }
		}
		if(!is.null(head)) {
			cat(format_text(head, prefix = NULL), file = file)
			cat("\n", file = file)
			cat("\n", file = file)
		}

		if(is.null(GetoptLong.options("__prefix__"))) {
	    	qqcat("Usage: Rscript @{script_name} [options]\n", file = file)
	    } else {
	    	qqcat("Usage: @{GetoptLong.options('__prefix__')} [options]\n", file = file)
	    }
	    qqcat("\n", file = file)

	    for(ig in seq_along(opt_group)) {

	    	ind = opt_group[[ig]]

		    qqcat("@{format_text(opt_group_desc[ig], prefix = NULL)}\n", file = file)
		    
		    style = match.arg(style)
		    if(style == "one-column") {
				for(i in ind) {
					cat(opt_lt[[i]]$help_message(), "\n", file = file)
				}
			} else {
				opt_line = NULL
				for(i in ind) {
					opt_line = c(opt_line, opt_lt[[i]]$help_message_two_columns(only_opt = TRUE))
				}
				opt_width = max(nchar(opt_line))

				for(i in ind) {
					cat(opt_lt[[i]]$help_message_two_columns(opt_width = opt_width), "\n", file = file)
				}
				cat("\n", file = file)
			}
		}

		if(!is.null(foot)) {
			cat(format_text(foot, prefix = NULL), file = file)
			cat("\n", file = file)
		}
	} else {

		lines = strsplit(template, "\n")[[1]]
		lines2 = NULL
		for(i in seq_along(lines)) {
			if(i == 1) {
				lines2[i] = lines[i]
			} else {
				if(grepl("^\\s{6,}\\w", lines[i], perl = TRUE)) {
					lines2[length(lines2)] = paste0(lines2[length(lines2)], " ",
						gsub("^\\s+", "", lines[i]))
				} else {
					lines2 = c(lines2, lines[i])
				}
			}
		}
		lines = lines2

		for(i in seq_along(lines)) {
			lt = find_code(GetoptLong.options("template_tag"), lines[i])
			if(length(lt$template) == 0) {
				cat(lines[i], "\n", file = file)
				next
			}

			for(j in seq_along(lt$template)) {
				for(k in seq_along(opt_lt)) {
					if(opt_lt[[k]]$spec == lt$code[j]) {

						data_type = TRUE
						if(!is.null(template_control$data_type)) {
							if(length(template_control$data_type) == 1 && is.null(names(template_control$data_type))) {
								data_type = template_control$data_type
							} else {
								data_type = template_control$data_type[opt_lt[[k]]$name]
								if(is.na(data_type)) data_type = TRUE
							}
						}

						opt_str = gsub("\n$", "", opt_lt[[k]]$help_message(prefix = "", which = "opt_line", data_type = data_type))

						opt_width = nchar(opt_str)
						if(!is.null(template_control$opt_width)) {
							if(length(template_control$opt_width) == 1 && is.null(names(template_control$opt_width))) {
								opt_width = template_control$opt_width
							} else {
								opt_width = template_control$opt_width[opt_lt[[k]]$name]
								if(is.na(opt_width)) opt_width = NULL
							}
						}

						prefix = strrep(" ", opt_width + 6)
						desc = gsub(lt$template[j], "", lines[[i]], fixed = TRUE)
						desc = gsub("^\\s+", "", desc)

						opt_str2 = paste0("  ", opt_str, strrep(" ", opt_width - nchar(opt_str)))
						cat(opt_str2, "    ", file = file, sep = "")
						
						desc = strwrap(desc, width = 0.9*GetoptLong.options$help_width - opt_width - 6)
						if(length(desc) > 1) {
							desc[-1] = paste0(prefix, desc[-1])
						}

						cat(paste(desc, collapse = "\n"), file = file)
						cat("\n", file = file)
					}
				}
			}
		}

	}
}

print_version_msg = function(envir, file = stderr()) {
	if(exists("VERSION", envir = envir)) {
		cat(as.character(get("VERSION", envir = envir, inherits = FALSE)), file = file)
	} else {
		cat("No version information is found in the script.", file = file)
	}
	cat("\n", file = file)
}

format_text = function(text, prefix = "  ", width = GetoptLong.options$help_width) {
	text = text
	text = gsub("^\\s+", "", text)
	if(is.null(prefix)) {
		text = strwrap(text, width = 0.9*(width))
		text = paste(text, collapse = "\n")
	} else {
		text = strwrap(text, width = 0.9*(width - nchar(prefix) - 2))
		text = paste(prefix, "  ", text, sep = "", collapse = "\n")
	}

	text
}

# == title
# Global options for GetoptLong() 
#
# == param
# -... Options, see 'Details' section.
# -RESET Whether to reset options to their default values.
# -READ.ONLY Whether to only return read-only options.
# -LOCAL Whether to switch local mode.
# -ADD Whether to add new options.
#
# == detail
# Supported global options are following:
#
# -``config`` Configuration of ``Getopt::Long``, check https://perldoc.pl/Getopt::Long#Configuring-Getopt::Long .
# -``template_tag`` The tag for identifying specifications in the template. The format should be in ``left_tag CODE right_tag``.
# -``help_style`` The style of the help message. 
#
# ``GetoptLong.options(...)`` should be put before calling `GetoptLong` function.
#
# == author
# Zuguang Gu <z.gu@dkfz.de>
#
GetoptLong.options = function(..., RESET = FALSE, READ.ONLY = NULL, LOCAL = FALSE, ADD = FALSE) {}
GetoptLong.options = setGlobalOptions(
	config = list(.value = NULL,
		          .class = "character"),
	template_tag = list(.value = "<CODE>",
						.length = 1,
						.validate = function(x) grepl("CODE", x)
					),
	help_style = list(.value = "one-column",
					 .length = 1,
					 .filter = function(x) {
					 	if(x == "one column") {
					 		x = "one-column"
					 	} else if(x == "one_column") {
					 		x = "one-column"
					 	} else if(x == "two column") {
					 		x = "two-column"
					 	} else if(x == "two_column") {
					 		x = "two-column"
					 	} else if(x == "two columns") {
					 		x = "two-column"
					 	} else if(x == "two_columns") {
					 		x = "two-column"
					 	}
					 	x
					 },
					 .validate = function(x) x %in% c("one-column", "two-column"),
					 .failed_msg = "help_style should be one of 'one-column' and 'two-column'"
					),
	"help_width" = 90,
	"__argv_str__" = list(.value = NULL,
						.length = c(0, 1),
						.visible = FALSE),
	"__script_name__" = list(.value = NULL,
		                    .private = TRUE,
		                    .visible = FALSE)
)

# == title
# Global options for qq() related functions
#
# == param
# -... Options, see 'Details' section.
# -RESET Whether to reset options to their default values.
# -READ.ONLY Whether to only return read-only options.
# -LOCAL Whether to switch local mode.
# -ADD Whether to add new options.
#
# == detail
# Supported options are following:
#
# -``cat_prefix`` prefix of the string which is printed by `qqcat`
# -``cat_verbose`` whether to print text by `qqcat`
# -``cat_strwrap`` whether call `base::strwrap` to wrap the string
# -``code.pattern`` code pattern for variable interpolation
#
# == author
# Zuguang Gu <z.gu@dkfz.de>
#
# == example
# a = 1
# qq.options(cat_prefix = "[INFO] ")
# qqcat("a = @{a}\n")
# qq.options(cat_verbose = FALSE)
# qqcat("a = @{a}\n")
# qq.options(RESET = TRUE)
# qq.options(code.pattern = "`CODE`")
# qqcat("a = `a`\n")
# qq.options(RESET = TRUE)
qq.options = function(..., RESET = FALSE, READ.ONLY = NULL, LOCAL = FALSE, ADD = FALSE) {}
qq.options = setGlobalOptions(
	cat_prefix = list(.value = "",
					  .length = c(0, 1),
					  .class = c("character", "numeric", "NULL"),
					  .filter = function(x) {
						if(is.null(x)) {
							return('')
						} else {
							return(x)
						}
					  }),
	cat_verbose = list(.value = TRUE,
					   .class = "logical"),
	cat_strwrap = list(.value = FALSE,
					   .class = "logical"),
	code.pattern = list(.value = "@\\{CODE\\}",
						.length = 1,
						.class = "character")
)

SingleOption = setRefClass("SingleOption",
    fields = list(
    	"name" = "character",
    	"spec" = "character",
    	"desc" = "character",
    	"full_opt" = "character",
    	"has_default" = "logical",
    	"is_mandatory" = "logical",
    	"value" = "ANY",
    	"default" = "ANY",
    	"var_type" = "character",
    	"opt_type" = "character",
    	"sub_opt" = "ANY"
    )
)

DEFAULT_OPTIONS = c("help", "version")

SingleOption$methods(
	initialize = function(spec, desc = "", envir = parent.frame(4), ...) {
		obj = callSuper(...)
		full_opt_names = extract_opt_name(spec)
		opt_name = full_opt_names[1]
		
		if(!grepl("^[a-zA-Z_\\.][a-zA-Z0-9_\\.]*$", opt_name)) {
			stop_wrap("Option name in option (@{spec}) can only be a valid R variable name which only uses numbers, letters,'.' and '_' (It should match /^[a-zA-Z_\\.][a-zA-Z0-9_\\.]+$/).")
		}
	
		obj$name = opt_name
		obj$spec = spec
		obj$full_opt = full_opt_names
		obj$value = NULL
		obj$desc = desc
		if(grepl("^\\s*$", obj$desc)) obj$desc = "No description is provided."

		obj$is_mandatory = detect_mandatory_on_spec(spec)

		if(detect_optional_on_spec(spec)) {
			stop_wrap("type :[isfo] is not allowed, use =[isfo] instead.")
		}

		obj$var_type = detect_var_type(spec) # scalar/array/hash
		obj$opt_type = detect_opt_type(spec) # character/integer/numeric/logical/negatable_logical

		obj$has_default = FALSE
		obj$is_mandatory = TRUE
		obj$default = NULL
		obj$sub_opt = NULL

		# assign defaults
		if(exists(opt_name, envir = envir, inherits = FALSE)) {
			v = get(opt_name, envir = envir, inherits = FALSE)
			if(is.function(v)) {
				obj$has_default = FALSE
				obj$is_mandatory = TRUE
				obj$default = NULL
			} else {
				obj$has_default = TRUE
				obj$default = v
				obj$is_mandatory = FALSE
			}
		}

		if(obj$opt_type == "negatable_logical") {
			if(!obj$has_default) {
				obj$has_default = TRUE
				obj$default = FALSE
				obj$is_mandatory = FALSE
			}
		} else if(obj$opt_type == "logical") {
			if(obj$has_default) {
				message_wrap(qq("The default of `@{opt_name}` is ignored unless the specification is set as '@{opt_name}!'. Reset it to FALSE."))
			}
			obj$has_default = TRUE
			obj$default = FALSE
			obj$is_mandatory = FALSE
		}

		## check the format of the default value
		v = obj$default
		if(obj$has_default && !obj$name %in% DEFAULT_OPTIONS) {
			if(!is.null(v)) {
				if(obj$opt_type == "logical") {
					
				} else if(obj$opt_type == "negatable_logical") {
					if(!(identical(v, TRUE) || identical(v, FALSE))) {
						if(is.atomic(v) && is.vector(v)) {
							if(length(v) > 1) {
								obj$default = TRUE
							} else if(length(v) == 1 ) {
								if(is.na(v)) {
									obj$default = FALSE
								} else if(is.numeric(v)) {
									obj$default = as.logical(v)
								} else if(is.character(v)) {
									if(grepl("^\\s*$", v)) {
										obj$default = FALSE
									} else {
										obj$default = TRUE
									}
								} else {
									obj$default = FALSE
								}
							} else {
								obj$default = FALSE
							}
						} else {
							if(length(v) > 1) {
								obj$default = TRUE
							} else {
								obj$default = FALSE
							}
						} 
						message_wrap(qq("The default of `@{opt_name}` should be a logical scalar. Reset `@{opt_name}` as @{obj$default}."))
					}
				} else if(obj$var_type == "scalar") {
					if(length(v) != 1) {
						stop_wrap(qq("`@{opt_name}` is set as a scalar. The length of it must be 1."))
					}
					if(!(is.atomic(v) && is.vector(v))) {
						stop_wrap(qq("`@{opt_name}` is set as a scalar. The value should be an atomic scalar."))
					}
					if(obj$opt_type %in% c("integer", "numeric")) {
						if(is.na(v) && !is.numeric(v)) {
							if(.self$opt_type == "integer") {
								v = NA_integer_
							} else {
								v = NA_real_
							}
							.self$default = v
						}
						if(!is.numeric(v)) {
							stop_wrap(qq("`@{opt_name}` is set in integer/numeric. The value must be number."))
						}
					}
					if(obj$opt_type == "character") {
						if(is.na(v) && !is.character(v)) {
							v = NA_character_
							.self$default = v
						}
						if(!is.character(v)) {
							stop_wrap(qq("`@{opt_name}` is set in character. The value must be a character."))
						}
					}
				} else if(obj$var_type == "array") {
					if(!(is.atomic(v) && is.vector(v))) {
						stop_wrap(qq("`@{opt_name}` is set as an array. The value should be an atomic vector"))
					}
					if(obj$opt_type %in% c("integer", "numeric")) {
						if(!is.numeric(v)) {
							stop_wrap(qq("`@{opt_name}` is set in integer/numeric. The value must be number."))
						}
					}
					if(obj$opt_type == "character") {
						if(!is.character(v)) {
							stop_wrap(qq("`@{opt_name}` is set in character. The value must be a character."))
						}
					}
				} else if(obj$var_type == "hash") {
					if(!is.list(v)) {
						stop_wrap(qq("`@{opt_name}` is set as a hash. The value should be a list."))
					}
					if(is.null(names(v))) {
						stop_wrap(qq("`@{opt_name}` is set as a hash. The value should be a named list."))
					}
					for(i in seq_along(v)) {
						if(!(is.atomic(v[[i]]) && is.vector(v[[i]]))) {
							stop_wrap(qq("`@{opt_name}` is set as an hash. The value should be an atomic vector."))
						}
						if(obj$opt_type %in% c("integer", "numeric")) {
							if(!is.numeric(v[[i]])) {
								stop_wrap(qq("`@{opt_name}` is set in integer/numeric. The value must be number."))
							}
						}
						if(obj$opt_type == "character") {
							if(!is.character(v[[i]])) {
								stop_wrap(qq("`@{opt_name}` is set in character. The value must be a character."))
							}
						}
					}
				}
			}
		}

		return(obj)
	}
)

SingleOption$methods(
	set_opt = function(v) {
		if(.self$var_type == "hash") {
			if(.self$has_default) {
				old_nm = setdiff(names(.self$default), names(v))
				v = c(v, .self$default[old_nm])
			}
		}
		.self$value = v
	}
)

SingleOption$methods(
	validate_mandatory = function(v) {
		if(missing(v)) v = .self$value
		if(is.null(v)) {
			if(.self$is_mandatory) {
				return(FALSE)
			}
		}
		TRUE
	}
)

SingleOption$methods(
	help_message = function(prefix = "  ", width = GetoptLong.options$help_width, 
		which = c("opt_line", "desc_line"), data_type = TRUE) {

		msg = ""

		if("opt_line" %in% which) {
			opt_line = NULL
			for(nm in .self$full_opt) {
				if(nchar(nm) == 1) {
					opt_line = c(opt_line, qq("-@{nm}"))
				} else {
					opt_line = c(opt_line, qq("--@{nm}"))
				}
			}
			opt_line = paste(opt_line, collapse = ", ")
			opt_line = paste0(prefix, opt_line)

			# data type
			if(data_type) {
				if(.self$var_type == "scalar") {
					if(.self$opt_type == "logical") {

					} else if(.self$opt_type == "negatable_logical") {
						opt_line = paste0(opt_line, ", -no-", .self$name)
					} else {
						opt_line = paste0(opt_line, " ", .self$opt_type)
					}
				} else if(.self$var_type == "array") {
					opt_line = paste0(opt_line, " ", qq("[@{.self$opt_type}, ...]"))
				} else if(.self$var_type == "hash") {
					opt_line = paste0(opt_line, " ", qq("{name=@{.self$opt_type}, ...}"))
				}
			}
			msg = paste0(msg, opt_line, "\n")
		}

		if("desc_line" %in% which) {
			desc_line = format_text(.self$desc, prefix = prefix, width = width)

			msg = paste0(msg, desc_line, "\n")
			default_str = .self$default_as_string()
			if(!is.null(default_str)) {
				msg = paste0(msg, prefix, "  ", "[default: ", default_str, "]\n")
			}

			abbr = c("character" = "chr", "integer" = "int", "extended_integer" = "int", "numeric" = "num")

			if(.self$var_type == "hash") {
				if(!is.null(.self$sub_opt)) {
					sub_opt_line = paste0("\n", prefix, "  Sub named options:\n")
					so = .self$sub_opt
					for(nm in names(so)) {
						str1 = paste0(prefix, "  ", nm, qq("=@{.self$opt_type}"))
						str2 = format_text(so[nm], prefix = paste0(prefix, strrep(" ", nchar(str1) + 1 - nchar(prefix) - 2)))
						substr(str2, 1, nchar(str1)) = str1
						sub_opt_line = paste0(sub_opt_line, str2, "\n")
					}

					msg = paste0(msg, sub_opt_line)
				}
			}
		}

		return(msg)
	}
)

SingleOption$methods(
	help_message_two_columns = function(prefix = "  ", only_opt = FALSE, opt_width = NULL,
		width = max(GetoptLong.options$help_width, opt_width + 60)) {
		
		opt_line = NULL
		for(nm in .self$full_opt) {
			if(nchar(nm) == 1) {
				opt_line = c(opt_line, qq("-@{nm}"))
			} else {
				opt_line = c(opt_line, qq("--@{nm}"))
			}
		}
		opt_line = paste(opt_line, collapse = ", ")
		opt_line = paste0(prefix, opt_line)

		abbr = c("character" = "chr", "integer" = "int", "extended_integer" = "int", "numeric" = "num")

		if(.self$var_type == "scalar") {
			if(.self$opt_type == "logical") {

			} else if(.self$opt_type == "negatable_logical") {
				opt_line = paste0(opt_line, ", -no-", .self$name)
			} else {
				opt_line = c(opt_line, paste0(prefix, "  [type: ", abbr[.self$opt_type], "]"))
			}
		} else if(.self$var_type == "array") {
			opt_line = c(opt_line, paste0(prefix, "  [type: ", qq("[@{abbr[.self$opt_type]}, ...]"), "]"))
		} else if(.self$var_type == "hash") {
			opt_line = c(opt_line, paste0(prefix, "  [type: ", qq("{name=@{abbr[.self$opt_type]}, ...}"), "]"))
		}
		
		if(only_opt) {
			return(opt_line)
		}

		prefix2 = strrep(" ", opt_width + 2)
		desc_line = format_text(.self$desc, prefix = prefix2, width = width)

		default_str = .self$default_as_string()
		if(!is.null(default_str)) {
			desc_line = paste0(desc_line, prefix2, "\n", prefix2, "  ", "[default: ", default_str, "]")
		}

		if(.self$var_type == "hash") {
			if(!is.null(.self$sub_opt)) {
				sub_opt_line = paste0(prefix2, "\n", prefix2, "  Sub named options:\n")
				so = .self$sub_opt
				for(nm in names(so)) {
					str1 = paste0(prefix2, "  ", nm, qq("=@{abbr[.self$opt_type]}"))
					str2 = format_text(so[nm], prefix = paste0(prefix2, strrep(" ", nchar(str1) + 1 - nchar(prefix2) - 2)))
					substr(str2, 1, nchar(str1)) = str1
					sub_opt_line = paste0(sub_opt_line, str2, "\n")
				}
				desc_line = paste0(desc_line, prefix2, "\n", sub_opt_line, "\n")
			}
		}

		desc_line = strsplit(desc_line, "\n")[[1]]

		n1 = length(opt_line)
		n2 = length(desc_line)
		msg = character(max(n1, n2))
		for(i in seq_along(msg)) {
			if(i <= n1 && i <= n2) {
				msg[i] = desc_line[i]
				substr(msg[i], 1, nchar(opt_line[i])) = opt_line[i]
			} else if(i > n1) {
				msg[i] = desc_line[i]
			} else if(i > n2) {
				msg[i] = opt_line[i]
			}
		}

		paste(msg, collapse = "\n")

	}
)

SingleOption$methods(
	default_as_string = function() {
		if(.self$has_default) {
			if(.self$opt_type == "logical") {
				return(NULL)
			} else if(.self$opt_type == "negatable_logical") {
				if(.self$default) {
					return("on")
				} else {
					return("off")
				}
			} else if(.self$var_type == "scalar") {
				if(is.null(.self$default)) {
					return("NULL")
				} else {
					return(as.character(.self$default))
				}
			} else if(.self$var_type == "array") {
				if(is.null(.self$default)) {
					return("NULL")
				} else {
					return(paste(.self$default, collapse = ", "))
				}
			} else if(.self$var_type == "hash") {
				if(is.null(.self$default)) {
					return("NULL")
				} else {
					return(paste(names(.self$default), .self$default, sep = "=", collapse = ", "))
				}
			}
		} else {
			return(NULL)
		}
	}
)

extract_opt_name = function(spec) {
	spec = gsub("[$@%]$", "", spec)
	spec = gsub("\\{.*\\}$", "", spec)
	spec = gsub("[=:][siof]$", "", spec)
	spec = gsub("[!+]$", "", spec)

	strsplit(spec, "\\|")[[1]]
}

detect_mandatory_on_spec = function(spec) {
	spec = gsub("[$@%]$", "", spec)
	spec = gsub("\\{.*\\}$", "", spec)
	
	grepl("=[siof]$", spec)
}

detect_optional_on_spec = function(spec) {
	spec = gsub("[$@%]$", "", spec)
	spec = gsub("\\{.*\\}$", "", spec)
	
	grepl(":[siof]$", spec)
}

# variable type
detect_var_type = function(opt) {
	sapply(opt, function(x) {
		if (grepl("\\$$", x)) {
			return("scalar")
		} else if (grepl("@$", x)) {
			return("array")
		} else if (grepl("%$", x)) {
			return("hash")
		} else if (grepl("\\{\\d?,?\\d?\\}$", x)) {
			return("array")
		} else {
			return("scalar")
		}
	}, USE.NAMES = FALSE)
}

# storage type
detect_opt_type = function(opt) {
	
	opt = gsub("[$@%]$", "", opt)
	opt = gsub("\\{.*\\}$", "", opt)
	
	sapply(opt, function(x) {
		if (grepl("[=:]s$", x)) {
			return("character")
		} else if (grepl("[=:]i$", x)) {
			return("integer")
		} else if (grepl("[=:]o$", x)) {
			return("extended_integer")
		} else if (grepl("[=:]f$", x)) {
			return("numeric")
		} else if (grepl("!$", x)) {
			return("negatable_logical")
		} else if (grepl("\\+$", x)) {
			return("integer")
		} else {
			return("logical")
		}
	}, USE.NAMES = FALSE)
}



stop_wrap = function (...) {
    x = paste0(...)
    x = paste(strwrap(x), collapse = "\n")
    stop(x, call. = FALSE)
}

warning_wrap = function (...) {
    x = paste0(...)
    x = paste(strwrap(x), collapse = "\n")
    warning(x, call. = FALSE)
}

message_wrap = function (...) {
    x = paste0(...)
    x = paste(strwrap(x), collapse = "\n")
    message(x)
}

generate_perl_script = function(opt_lt, json_file) {

	perl_script = tempfile(fileext = ".pl")
	#perl_script = "tmp.pl"
	
	# construct perl code
	perl_code = NULL
	perl_code = c(perl_code, qq("#!/usr/bin/perl"))
	perl_code = c(perl_code, qq(""))
	perl_lib = qq("@{system.file('extdata', package='GetoptLong')}/perl_lib")
	perl_code = c(perl_code, qq("BEGIN { push (@INC, '@{perl_lib}'); }"))
	perl_code = c(perl_code, qq(""))
	perl_code = c(perl_code, qq("use strict;"))
	
	config = NULL
	if(!is.null(options("GetoptLong.Config")[[1]]) && is.null(GetoptLong.options("config"))) {
		config = options("GetoptLong.Config")[[1]]
	} else {
		config = GetoptLong.options("config")
	}
	if(is.null(config)) {
		perl_code = c(perl_code, qq("use Getopt::Long;"))
	} else {
		perl_code = c(perl_code, qq("use Getopt::Long qw(:config @{paste(config, collapse = ' ')});"))
	}
	
	perl_code = c(perl_code, qq("use JSON;"))
	perl_code = c(perl_code, qq("use Data::Dumper;"))
	perl_code = c(perl_code, qq(""))

	n = length(opt_lt)

	# declare variables according to variable types
	for (i in seq_len(n)) {
		opt = opt_lt[[i]]
		perl_code = c(perl_code, qq("my @{perl_sigil(opt$var_type)}opt_@{i};"))
		
		if(opt$var_type == "negatable_logical") {
			perl_code = c(perl_code, qq("@{perl_sigil(opt$var_type)}opt_@{i} = @{opt$opt_default + 0};"))
		}
	}
	
	perl_code = c(perl_code, qq("*STDERR = *STDOUT;")) # all write to STDOUT
	perl_code = c(perl_code, qq("my $is_successful = GetOptions("))
	
	for (i in seq_len(n)) {
		opt = opt_lt[[i]]
		perl_code = c(perl_code, qq("    '@{opt$spec}' => \\@{perl_sigil(opt$var_type)}opt_@{i},"))
	}
	perl_code = c(perl_code, qq(");"))
	
	perl_code = c(perl_code, qq("if(!$is_successful) {"))
	perl_code = c(perl_code, qq("    exit;"))
	perl_code = c(perl_code, qq("}"))
	
	# if var_type == integer or numberic, value should be forced ensured
	for(i in seq_len(n)) {
		opt = opt_lt[[i]]
		if(opt$opt_type %in% c("integer", "numeric")) {
			
			if(opt$var_type == "scalar") {
			
				perl_code = c(perl_code, qq("if(defined(@{perl_sigil(opt$var_type)}opt_@{i})) {"))
				perl_code = c(perl_code, qq("    $opt_@{i} += 0;"))
				perl_code = c(perl_code, "}")
				
			} else if(opt$var_type == "array") {
				
				# if array is defined
				perl_code = c(perl_code, qq("if(@opt_@{i}) {"))
				perl_code = c(perl_code, qq("    foreach (@opt_@{i}) { $_ += 0; }"))
				perl_code = c(perl_code, "}")
				
			} else if(opt$var_type == "hash") {
				
				# if hash is defined
				perl_code = c(perl_code, qq("if(%opt_@{i}) {"))
				perl_code = c(perl_code, qq("    foreach (keys %opt_@{i}) { $opt_@{i}{$_} += 0; }"))
				perl_code = c(perl_code, "}")
				
			}
			
		}
	}
	perl_code = c(perl_code, qq(""))
	
	perl_code = c(perl_code, qq("my $all_opt = {"))
	
	for (i in seq_len(n)) {
		opt = opt_lt[[i]]
	
		if(opt$opt_type == "logical") {
		
			perl_code = c(perl_code, qq("    '@{opt$name}' => $opt_@{i} ? JSON::true : JSON::false,"))

		} else if(opt$opt_type == "negatable_logical") {
		
			perl_code = c(perl_code, qq("    '@{opt$name}' => $opt_@{i} ? JSON::true : JSON::false,"))

		} else if(opt$var_type == "scalar") {
			
			perl_code = c(perl_code, qq("    '@{opt$name}' => $opt_@{i},"))

		} else {
			
			# in scalar content, empty list will be 0
			perl_code = c(perl_code, qq("    '@{opt$name}' => scalar(@{perl_sigil(opt$var_type)}opt_@{i}) ? \\@{perl_sigil(opt$var_type)}opt_@{i} : undef,"))

		}
	}
	
	perl_code = c(perl_code, qq("};"))
	perl_code = c(perl_code, qq(""))

	perl_code = c(perl_code, qq("open JSON, '>@{json_file}' or die 'Cannot create temp file: @{json_file}\\n';"))
	perl_code = c(perl_code, qq("print JSON to_json($all_opt, {pretty => 1});"))
	perl_code = c(perl_code, qq("close JSON;"))
	# perl_code = c(perl_code, qq("print STDERR Dumper $all_opt;"))

	writeLines(perl_code, perl_script)
	return(perl_script)
}

perl_sigil = function(type) {
	if(type == "scalar") {
		return("$")
	} else if(type == "array") {
		return("@")
	} else if(type == "hash") {
		return("%")
	} else {
		return("$")
	}
}


# find path of binary perl
find_perl_bin = function(con = stderr(), from_command_line = TRUE) {

	# first look at user's options
	args = commandArgs()
	i = which(args == "--")
	if(length(i) && length(args) > i) {
		perl_bin = args[i + 1]
		
		if(!file.exists(perl_bin)) {
			cat(red(qq("Cannot find @{perl_bin}\n")), file = con)
			if(from_command_line) {
				q(save = "no", status = 127)
			} else {
				return(invisible(NULL))
			}
		}
		
		if(file.info(perl_bin)$isdir) {
			cat(red(qq("@{perl_bin} should be a file, not a directory.\n")), file = con)
			if(from_command_line) {
				q(save = "no", status = 127)
			} else {
				return(invisible(NULL))
			}
		}
		
	} else {  # look at PATH
		perl_bin = Sys.which("perl")
		if(perl_bin == "") {
			cat(red("Cannot find Perl in PATH.\n"), file = con)
			if(from_command_line) {
				q(save = "no", status = 127)
			} else {
				return(invisible(NULL))
			}
		}
	}
	
	return(perl_bin)
}

# check whether perl can be called
# check whether perl has certain module
check_perl = function(module = NULL, inc = NULL, perl_bin = "perl") {
	
	if(is.null(module)) {
		cmd = qq("\"@{perl_bin}\" -v")
	} else if(!is.null(module) && is.null(inc)) {
		cmd = qq("\"@{perl_bin}\" -M@{module} -e \"use @{module}\"")
	} else if(!is.null(module) && !is.null(inc)) {
		cmd = qq("\"@{perl_bin}\" \"-I@{inc}\" -M@{module} -e \"use @{module}\"")
	}
	
	OS = Sys.info()["sysname"]
	if(OS == "Windows") {
		res = system(cmd, ignore.stdout = TRUE, ignore.stderr = TRUE, show.output.on.console = FALSE)
	} else {
		res = system(cmd, ignore.stdout = TRUE, ignore.stderr = TRUE)
	}

	return(ifelse(res, FALSE, TRUE))
}

# == title
# Wrapper of the Perl module ``Getopt::Long`` in R
#
# == param
# -...     Specification of options. The value can be a two-column matrix, a vector with even number of elements 
#          or a text template. See the vignette for detailed explanation.
# -help_head Head of the help message when invoking ``Rscript foo.R --help``.
# -help_foot Foot of the help message when invoking ``Rscript foo.R --help``.
# -envir    User's enrivonment where `GetoptLong` looks for default values and exports variables.
# -argv_str A string that contains command-line arguments. It is only for testing purpose.
# -template_control A list of parameters for controlling when the specification is a template.
# -help_style The style of the help messages. Value should be either "one-column" or "two-column".
#
# == details
# Following shows a simple example. Put following code at the beginning of your script (e.g. ``foo.R``):
#
#     library(GetoptLong)
#     
#     cutoff = 0.05
#     GetoptLong(
#         "number=i", "Number of items.",
#         "cutoff=f", "Cutoff for filtering results.",
#         "verbose",  "Print message."
#     )
#
# Then you can call the script from command line either by:
#
#     Rscript foo.R --number 4 --cutoff 0.01 --verbose
#     Rscript foo.R --number 4 --cutoff=0.01 --verbose
#     Rscript foo.R -n 4 -c 0.01 -v
#     Rscript foo.R -n 4 --verbose
#
# In this example, ``number`` is a mandatory option and it should only be in
# integer mode. ``cutoff`` is optional and it already has a default value 0.05.
# ``verbose`` is a logical option. If parsing is successful, two variables ``number``
# and ``verbose`` will be imported into the working environment with the specified
# values. Value for ``cutoff`` will be updated if it is specified in command-line.
#
# For advanced use of this function, please go to the vignette.
#
# == author
# Zuguang Gu <z.gu@dkfz.de>
#
GetoptLong = function(..., help_head = NULL, help_foot = NULL, envir = parent.frame(), 
	argv_str = NULL, template_control = list(), 
	help_style = GetoptLong.options$help_style) {

	if(is.null(get_scriptname())) {
		IS_UNDER_COMMAND_LINE = FALSE
	} else {
		IS_UNDER_COMMAND_LINE = TRUE
	}

	if(is.null(argv_str)) {
		argv_str = GetoptLong.options("__argv_str__")
	}
	on.exit(GetoptLong.options("__argv_str__" = NULL))

	# to test whether the script is run under command-line or in R interactive environment
	if(IS_UNDER_COMMAND_LINE || is.null(argv_str)) {
		OUT = stderr()
	} else {
		OUT = stdout()  # message from STDOUT is important under testing mode
	}

	############### parse specification ##################

	spec = list(...)

	# a vector or a two-column matrix
	if(length(spec) == 1) {
		spec = spec[[1]]
	} else {
		spec = unlist(spec)
	}

	# check first argument
	# it should be a matrix with two columns or a vector with even number of elements
	template = NULL
	if(is.matrix(spec)) {
		if(ncol(spec) != 2) {
			stop_wrap("If your specification is a matrix, it should be a two-column matrix.")
		}
	} else {
		if(is.vector(spec)) {
			if(length(spec) == 1) {
				template = spec
				template = gsub("^\\n", "", template)
				spec = parse_spec_template(spec)
				if(nrow(spec) == 0) {
					stop_wrap("Cannot detect option specification in the template.")
				}
			} else if(length(spec) %% 2) {
				stop_wrap("Since your specification is a vector, it should have even number of elements.")
			} else {
				spec = matrix(spec, ncol = 2, byrow = TRUE)
			}
		} else {
			stop_wrap("Wrong specification.")
		}
	}
	
	##### extract specification for hash
	l_sub_opt = grepl("\\w+\\$\\S+$", spec[, 1])
	hash_sub_opt = spec[l_sub_opt, , drop = FALSE]
	spec = spec[!l_sub_opt, , drop = FALSE]
	spec[, 1] = gsub("\\s*", "", spec[, 1])

	#### convert hash_sub_opt into a list
	sub_opt = NULL
	if(sum(l_sub_opt)) {
		sub_opt = lapply(split(seq_len(nrow(hash_sub_opt)), gsub("\\$.*$", "", hash_sub_opt[, 1])), function(ind) {
			nm = apply(hash_sub_opt[ind, , drop = FALSE], 1, function(x) {
				gsub("^.*?\\$", "", x[1])
			})
			structure(hash_sub_opt[ind, 2], names = nm)
		})
	}

	### opt groups
	l_opt_group = grepl("^[-=\\+#%]*$", spec[, 1])
	if(any(l_opt_group)) {
		i_opt = 0
		i_group = 0
		opt_group = list()
		opt_group_desc = NULL
		if(!l_opt_group[1]) {
			opt_group[[1]] = list()
			opt_group_desc = ""
			i_group = 1
		}
		for(i in seq_along(l_opt_group)) {
			if(l_opt_group[i]) {
				i_group = i_group + 1
				opt_group[[i_group]] = list()
				opt_group_desc = c(opt_group_desc, spec[i, 2])
			} else {
				i_opt = i_opt + 1
				opt_group[[i_group]] = c(opt_group[[i_group]], i_opt)
			}
		}
		spec = spec[!l_opt_group, , drop = FALSE]
	} else {
		opt_group = list(1:nrow(spec))
		opt_group_desc = "Options:"
	}

	if(is.list(envir)) envir = as.environment(envir)

	############### construct a list of SingleOption objects ####################
	opt_lt = list()
	for(i in seq_len(nrow(spec))) {
		opt_lt[[i]] = SingleOption(spec = spec[i, 1], desc = spec[i, 2], envir = envir)
	}
	names(opt_lt) = sapply(opt_lt, function(x) x$name)

	if("help" %in% names(opt_lt)) {
		stop_wrap("`help` is reserved as a default option. Please do not use it.")
	}
	
	if("version" %in% names(opt_lt)) {
		stop_wrap("`version` is reserved as a default option. Please do not use it.")
	}
	
	opt_lt$help = SingleOption(spec = "help", "Print help message and exit.")
	opt_lt$version = SingleOption(spec = "version", "Print version information and exit.")
	n_opt = length(opt_lt)

	opt_group[[length(opt_group)]] = c(opt_group[[length(opt_group)]], n_opt - 1, n_opt)

	if(!is.null(sub_opt)) {
		for(i in seq_len(n_opt)) {
			if(opt_lt[[i]]$name %in% names(sub_opt) && opt_lt[[i]]$var_type == "hash") {
				opt_lt[[i]]$sub_opt = sub_opt[[ opt_lt[[i]]$name ]]
			}
		}
	}

	## add short opt name
	first_letter = lapply(opt_lt, function(opt) {
		full_opt = opt$full_opt
		substr(full_opt, 1, 1)
	})
	first_letter_tb = table(unlist(first_letter))[unique(unlist(first_letter))]
	first_letter_unique = names(first_letter_tb[first_letter_tb == 1])
	for(le in first_letter_unique) {
		ind = which(sapply(first_letter, function(x) any(x == le)))
		opt_lt[[ind]]$full_opt = unique(c(opt_lt[[ind]]$full_opt, le))
	}

	# get the path of binary perl
	# it will look in PATH and also user's command-line argument
	perl_bin = find_perl_bin(con = OUT, from_command_line = IS_UNDER_COMMAND_LINE)

	# check whether Getopt::Long is in @INC
	# normally, it is shippped with standard Perl distributions
	if(!check_perl("Getopt::Long", perl_bin = perl_bin)) {
		cat(red("Error: Cannot find Getopt::Long module in your Perl library.\n"), file = OUT)
		if(IS_UNDER_COMMAND_LINE) {
			q(save = "no", status = 127)
		} else if(!is.null(argv_str)) {  # under test
			return(invisible(NULL))
		} else {
			stop("You have an error.\n")
		}
	}
	
	# check whether JSON is in @INC
	if(!check_perl("JSON", inc = qq("@{system.file('extdata', package='GetoptLong')}/perl_lib"), perl_bin = perl_bin)) {
		cat(red("Error: Cannot find JSON module in your Perl library.\n"), file = OUT)
		
		if(IS_UNDER_COMMAND_LINE) {
			q(save = "no", status = 127)
		} else if(!is.null(argv_str)) {  # under test
			return(invisible(NULL))
		} else {
			stop("You have an error.\n")
		}
	}

	json_file = tempfile(fileext = ".json")
	perl_script = generate_perl_script(opt_lt, json_file)
	
	# get arguments string
	if(is.null(argv_str)) {
		ARGV = commandArgs(TRUE)
		ARGV_string = reformat_argv_string(opt_lt, ARGV)
	} else {
		if(grepl("'|\\\"", argv_str)) {
			ARGV_string = argv_str
		} else {
			ARGV_string = reformat_argv_string(opt_lt, strsplit(argv_str, "\\s+")[[1]])
		}
	}

	cmd = qq("\"@{perl_bin}\" \"@{perl_script}\" @{ARGV_string}");
	res = system(cmd, intern = TRUE)
	res = as.vector(res)

	script_name = NULL

	# if you specified wrong arguments
	if(length(res)) {
		cat(red(qq("Error: @{res}\n")), file = OUT)
		
		print_help_msg(opt_lt, file = OUT, script_name = script_name, head = help_head, foot = help_foot,
			template = template, template_control = template_control, style = help_style,
			opt_group = opt_group, opt_group_desc = opt_group_desc)
		
		suppressWarnings({
			file.remove(json_file)
			file.remove(perl_script)
		})
		
		if(IS_UNDER_COMMAND_LINE) {
			q(save = "no", status = 127)
		} else if(!is.null(argv_str)) {  # under test
			return(invisible(NULL))
		} else {
			stop("You have an error.\n")
		}
	}
	
	# if arguments are correct, values for options will be stored in .json file
	opt_json = fromJSON(file = json_file)
	suppressWarnings({
		file.remove(json_file)
		file.remove(perl_script)
	})

	for(opt_name in names(opt_json)) {
		opt = opt_lt[[opt_name]]
		opt$set_opt(opt_json[[opt_name]])
		opt_lt[[opt_name]] = opt
	}

	## logical options always have values no matter they are specified or not
	## reset the value to NULL if they are not specified.
	for(opt_name in names(opt_json)) {
		opt = opt_lt[[opt_name]]
		if(opt$opt_type == "negatable_logical") {
			if(!negatable_logical_is_called(opt_name, ARGV_string)) {
				opt$set_opt(NULL)
			}
		}
	}

	if(opt_json$help) {
		print_help_msg(opt_lt, file = stdout(), script_name = script_name, head = help_head, foot = help_foot, 
			template = template, template_control = template_control, style = help_style,
			opt_group = opt_group, opt_group_desc = opt_group_desc)
		
		if(IS_UNDER_COMMAND_LINE) {
			q(save = "no", status = 0)
		} else if(!is.null(argv_str)) {  # under test
			return(invisible(NULL))
		} else {
			stop("You have an error.\n")
		}
	}
	
	if(opt_json$version) {
		print_version_msg(envir, file = stdout())
		
		if(IS_UNDER_COMMAND_LINE) {
			q(save = "no", status = 0)
		} else if(!is.null(argv_str)) {  # under test
			return(invisible(NULL))
		} else {
			stop("You have an error.\n")
		}
	}

	# check mandatory options
	for(opt_name in names(opt_json)) {
		if(!opt_lt[[opt_name]]$validate_mandatory(opt_json[[opt_name]])) {
			cat(red(qq("Error: `@{opt_name}` is mandatory\n")), file = OUT)

			print_help_msg(opt_lt, file = OUT, script_name = script_name, head = help_head, foot = help_foot,
				template = template, template_control = template_control, style = help_style,
				opt_group = opt_group, opt_group_desc = opt_group_desc)
			if(IS_UNDER_COMMAND_LINE) {
				q(save = "no", status = 127)
			} else if(!is.null(argv_str)) {  # under test
				return(invisible(NULL))
			} else {
				stop_wrap("You have an error.\n")
			}
		}
	}
	
	export_to_parent_frame(opt_lt, envir = envir)
	
	return(invisible(opt_lt))
}


# test whether long_name is called in argv_str
# negatable_logical_is_called("verbose", "--verbose")
# negatable_logical_is_called("verbose", "-verbose")
# negatable_logical_is_called("verbose", "--v")
# negatable_logical_is_called("verbose", "-v")
# negatable_logical_is_called("verbose", "--no-verbose")
negatable_logical_is_called = function(long_name, argv_str) {
	argv = strsplit(argv_str, " ")[[1]]
	argv = argv[grepl("^-", argv)]
	if(length(argv)) {
		argv = gsub("^-+", "", argv)
		if(any(sapply(argv, function(x) grepl(qq("^@{x}"), long_name)))) {
			return(TRUE)
		} else {
			any(sapply(argv, function(x) grepl(qq("(no-?)?@{long_name}$"), x)))
		}
	} else {
		return(FALSE)
	}
}


# == title
# Wrapper of the Perl module ``Getopt::Long`` in R
#
# == param
# -... Pass to `GetoptLong`.
# -envir User's enrivonment where `GetoptLong` looks for default values and exports variables.
#
# == details
# This function is the same as `GetoptLong`. It is just to make it consistent as the ``GetOptions()`` 
# subroutine in ``Getopt::Long`` module in Perl.
#
# == author
# Zuguang Gu <z.gu@dkfz.de>
#
GetOptions = function(..., envir = parent.frame()) GetoptLong(..., envir = envir)

export_to_parent_frame = function(opt_lt, envir = parent.frame()) {

	n = length(opt_lt)
	for(i in seq_len(n)) {
		opt = opt_lt[[i]]
		if(opt$name %in% c("help", "version")) {
			next
		}

		if(!is.null(opt$value)) {
			v = opt$value
			assign(opt$name, v, envir = envir)
		}
	}
	return(invisible(NULL))
}


# == title
# File name of current script
#
# == value
# If the R script is not run from the command-line, it returns ``NULL``.
#
# == author
# Zuguang Gu <z.gu@dkfz.de>
#
get_scriptname = function() {
	args = commandArgs()
	
	if(length(args) == 1) {
		return(NULL)
	}
    f = grep("^--file=", args, value = TRUE)
    if(length(f)) {
    	f = gsub("^--file=(.*)$", "\\1", f[1])
    	return(f)	
    } else {
    	return(GetoptLong.options("__script_name__"))
    }  
}

# == title
# Directory of current script
#
# == value
# If the R script is not run from the command-line, it returns ``NULL``.
#
# == author
# Zuguang Gu <z.gu@dkfz.de>
#
get_scriptdir = function() {
	args = commandArgs()
	
	f = grep("^--file=", args, value = TRUE)
    if(length(f)) {
    	f = gsub("^--file=(.*)$", "\\1", f[1])
    	return(dirname(normalizePath(f)))	
    } else {
    	return(NULL)
    }
}

# == title
# Source the R script with command-line arguments
#
# == param
# -file The R script
# -... Pass to `base::source`.
# -argv_str The command-line arguments.
#
source_script = function(file, ..., argv_str = NULL) {
	GetoptLong.options("__argv_str__" = argv_str)
	GetoptLong.options("__script_name__" = file)
	on.exit({
		GetoptLong.options("__script_name__" = NULL)
		GetoptLong.options("__argv_str__" = NULL)
	})

	base::source(file, ...)
}

source = function (file, ..., argv = NULL) {
    GetoptLong.options(`__argv_str__` = argv)
    GetoptLong.options(`__script_name__` = file)
    on.exit({
    	GetoptLong.options(`__script_name__` = NULL)
    	GetoptLong.options(`__argv_str__` = NULL)
    })
    base::source(file, ...)
}

parse_spec_template = function(template, match = GetoptLong.options("template_tag")) {
	lt = find_code(match, template)
	spec = cbind(lt$code, rep("", length(lt$code)))
	spec = spec[!grepl("^#", spec[, 1]), ,drop = FALSE]

	return(spec)
}

## careful when ARGV_string is --a '1 2 3' where '1, 2, 3' should not be split
reformat_argv_string = function(opt_lt, argv) {

	current_tag = NA
	tag_increment = 0
	argv2 = NULL

	for(i in seq_along(argv)) {
		if(grepl("^(-|\\+)", argv[i])) {
			current_tag = argv[i]
			tag_increment = 0
			argv2 = c(argv2, argv[i])
		} else {
			tag_increment = tag_increment + 1
			if(tag_increment == 1) argv2 = c(argv2, argv[i])
		}

		if(tag_increment >= 2) {
			opt  = look_up_opt_by_tag(opt_lt, current_tag)
			if(is.null(opt)) {
				argv2 = c(argv2, argv[i])
			} else {
				if(grepl("(@|%)$", opt$spec)) {
					argv2 = c(argv2, qq("--@{opt$name}"), argv[i])
				} else {
					argv2 = c(argv2, argv[i])
				}
			}
		}
	}

	argv2 = sapply(argv2, function(x) {
		if(grepl(" ", x)) {
			x = paste0("'", x, "'")
		} else {
			x
		}
	})

	paste(argv2, collapse = " ")
}

look_up_opt_by_tag = function(opt_lt, tag) {

	tag = gsub("^(-|--|\\+)", "", tag)
	ind = NULL
	for(i in seq_along(opt_lt)) {
		opt = opt_lt[[i]]
		if(tag %in% opt$full_opt) {
			ind = c(ind, i)
		} else if(any(grepl(qq("^@{tag}"), opt$full_opt))) {
			ind  = c(ind, i)
		}
	}
	if(length(ind) != 1) {
		return(NULL)
	} else {
		return(opt_lt[[ind]])
	}
}

## ----echo = FALSE, message = FALSE--------------------------------------------
library(knitr)
knitr::opts_chunk$set(
    error = FALSE,
    tidy  = FALSE,
    message = FALSE,
    comment = NA,
    fig.align = "center")
library(GetoptLong)

## ----echo = FALSE, out.width = "600px"----------------------------------------
include_graphics("workflow.png")

## ----simple, eval = FALSE-----------------------------------------------------
# library(GetoptLong)
# 
# cutoff = 0.05
# GetoptLong(
#     "number=i", "Number of items.",
#     "cutoff=f", "Cutoff for filtering results.",
#     "verbose",  "Print message."
# )

## ----echo = FALSE-------------------------------------------------------------
chunks <- knitr:::knit_code$get()
GetoptLong.options("__argv_str__" = "--help")
local({ eval(parse(text = chunks[["simple"]])) })
GetoptLong.options("__argv_str__" = NULL)

## ----echo = FALSE-------------------------------------------------------------
chunks <- knitr:::knit_code$get()
GetoptLong.options("__argv_str__" = "--help")
GetoptLong.options("help_style" = "two-column")
local({ eval(parse(text = chunks[["simple"]])) })
GetoptLong.options("__argv_str__" = NULL)
GetoptLong.options("help_style" = "one-column")

## ----template, eval = FALSE---------------------------------------------------
# spec = "
# This is an example of using template to specify options.
# 
# Usage: Rscript foo.R [options]
# 
# Options:
#   <number=i> Number of items.
#   <cutoff=f> Cutoff for filtering results.
#   <verbose> Print messages.
# 
# Contact: name@address
# "
# 
# GetoptLong(spec, template_control = list(opt_width = 21))

## ----echo = FALSE-------------------------------------------------------------
chunks <- knitr:::knit_code$get()
GetoptLong.options("__argv_str__" = "--help")
local({ eval(parse(text = chunks[["template"]])) })
GetoptLong.options("__argv_str__" = NULL)

## ----print_var, eval = FALSE--------------------------------------------------
# library(GetoptLong)
# 
# cutoff = 0.05
# GetoptLong(
#     "number=i{1,}", "Number of items.",
#     "cutoff=f", "Cutoff for filtering results.",
#     "param=s%", "Parameters specified by name=value pairs.",
#     "verbose",  "Print message."
# )
# 
# print(number)
# print(cutoff)
# print(param)
# print(verbose)

## ----echo = FALSE-------------------------------------------------------------
chunks <- knitr:::knit_code$get()
GetoptLong.options("__argv_str__" = "--number 1 2 --param var1=a var2=b --verbose")
local({ eval(parse(text = chunks[["print_var"]])) })
GetoptLong.options("__argv_str__" = NULL)

## ----eval = FALSE-------------------------------------------------------------
# verbose = TRUE
# GetoptLong(
#     "verbose!",  "Print message."
# )

## ----with_env, eval = FALSE---------------------------------------------------
# opt = new.env()
# 
# opt$cutoff = 0.05
# GetoptLong(
#     "number=i@", "Number of items.",
#     "cutoff=f", "Cutoff for filtering results.",
#     "param=s%", "Parameters specified by name=value pairs.",
#     "verbose",  "Print message.",
# 
#     envir = opt
# )
# print(as.list(opt))

## ----echo = FALSE-------------------------------------------------------------
chunks <- knitr:::knit_code$get()
GetoptLong.options("__argv_str__" = "--number 1 2 --param var1=a var2=b --verbose")
local({ eval(parse(text = chunks[["with_env"]])) })
GetoptLong.options("__argv_str__" = NULL)

## ----multi_word, eval = FALSE-------------------------------------------------
# # or a default can be set for `bar_value`
# # bar_value = 2
# GetoptLong(
#     "bar_value=i", "Some value."
# )
# print(bar_value)

## ----echo = FALSE-------------------------------------------------------------
chunks <- knitr:::knit_code$get()
GetoptLong.options("__argv_str__" = "--bar-value 1")
local({ eval(parse(text = chunks[["multi_word"]])) })
GetoptLong.options("__argv_str__" = NULL)

## ----multi_word_logical, eval = FALSE-----------------------------------------
# GetoptLong(
#     "show_messages!", "Whether to show messages?"
# )
# print(show_messages)

## ----echo = FALSE-------------------------------------------------------------
chunks <- knitr:::knit_code$get()
GetoptLong.options("__argv_str__" = "--show-messages")
local({ eval(parse(text = chunks[["multi_word_logical"]])) })
GetoptLong.options("__argv_str__" = NULL)

## ----echo = FALSE-------------------------------------------------------------
chunks <- knitr:::knit_code$get()
GetoptLong.options("__argv_str__" = "--no-show-messages")
local({ eval(parse(text = chunks[["multi_word_logical"]])) })
GetoptLong.options("__argv_str__" = NULL)

## ----complex_example, eval = FALSE--------------------------------------------
# GetoptLong(
#     "count=i",  paste("This is a count. This is a count. This is a count.",
#                       "This is a count.  This is a count. This is a count."),
#     "number=f", paste("This is a number. This is a number. This is a number.",
#                       "This is a number. This is a number. This is a number."),
#     "array=f@", paste("This is an array. This is an array. This is an array.",
#                       "This is an array. This is an array. This is an array."),
#     "hash=s%",  paste("This is a hash. This is a hash. This is a hash.",
#                       "This is a hash. This is a hash. This is a hash."),
#     "verbose!", "Whether show messages",
#     "flag",     "a non-sense option"
# )

## ----echo = FALSE-------------------------------------------------------------
chunks <- knitr:::knit_code$get()
GetoptLong.options("__argv_str__" = "--help")
local({ eval(parse(text = chunks[["complex_example"]])) })
GetoptLong.options("__argv_str__" = NULL)

## ----echo = FALSE-------------------------------------------------------------
chunks <- knitr:::knit_code$get()
GetoptLong.options("__argv_str__" = "--help")
local({ count = 1
    number = 0.1
    array = c(1, 2)
    hash = list("foo" = "a", "bar" = "b")
    verbose = TRUE
    eval(parse(text = chunks[["complex_example"]])) 
})
GetoptLong.options("__argv_str__" = NULL)

## ----eval = FALSE-------------------------------------------------------------
# GetoptLong.options(help_style = "two-column")
# # specifying the defaults
# GetoptLong{
#     ...
# }

## ----echo = FALSE-------------------------------------------------------------
chunks <- knitr:::knit_code$get()
GetoptLong.options("__argv_str__" = "--help")
GetoptLong.options("help_style" = "two-column")
local({ count = 1
    number = 0.1
    array = c(1, 2)
    hash = list("foo" = "a", "bar" = "b")
    verbose = TRUE
    eval(parse(text = chunks[["complex_example"]])) 
})
GetoptLong.options("__argv_str__" = NULL)
GetoptLong.options("help_style" = "one-column")

## ----sub_opt, eval = FALSE----------------------------------------------------
# foo = list(a = 1, b = 2)
# GetoptLong(
#     "foo=i%", paste("This is foo. This is foo. This is foo. This is foo.",
#                     "This is foo. This is foo. This is foo. This is foo."),
#     "foo$name1", paste("name1 in foo. name1 in foo. name1 in foo. name1 in foo.",
#                        "name1 in foo. name1 in foo. name1 in foo. name1 in foo."),
#     "foo$name2", paste("name2 in foo. name2 in foo. name2 in foo. name2 in foo.",
#                        "name2 in foo. name2 in foo. name2 in foo. name2 in foo."),
#     "bar=s%", paste("This is bar. This is bar. This is bar. This is bar.",
#                     "This is bar. This is bar. This is bar. This is bar."),
#     "bar$name3", paste("name3 in bar. name3 in bar. name3 in bar. name3 in bar.",
#                        "name3 in bar. name3 in bar. name3 in bar. name3 in bar."),
#     "bar$name4", paste("name4 in bar. name4 in bar. name4 in bar. name4 in bar.",
#                        "name4 in bar. name4 in bar. name4 in bar. name4 in bar.")
# )

## ----echo = FALSE-------------------------------------------------------------
chunks <- knitr:::knit_code$get()
GetoptLong.options("__argv_str__" = "--help")
local({ eval(parse(text = chunks[["sub_opt"]])) })
GetoptLong.options("__argv_str__" = NULL)

## ----eval = FALSE-------------------------------------------------------------
# GetoptLong.options(help_style = "two-column")
# GetoptLong{
#     ...
# }

## ----echo = FALSE-------------------------------------------------------------
chunks <- knitr:::knit_code$get()
GetoptLong.options("__argv_str__" = "--help")
GetoptLong.options(help_style = "two-column")
local({ eval(parse(text = chunks[["sub_opt"]])) })
GetoptLong.options("__argv_str__" = NULL)
GetoptLong.options(help_style = "one-column")

## ----head_and_foot, eval = FALSE----------------------------------------------
# GetoptLong(
#     help_head = "This is a demonstration of adding usage head and foot.",
# 
#     "number=i", "Number of items.",
#     "cutoff=f", "Cutoff for filtering results.",
#     "verbose",  "Print message.",
# 
#     help_foot = "Please contact name@address."
# )

## ----echo = FALSE-------------------------------------------------------------
chunks <- knitr:::knit_code$get()
GetoptLong.options("__argv_str__" = "--help")
local({ eval(parse(text = chunks[["head_and_foot"]])) })
GetoptLong.options("__argv_str__" = NULL)

## ----grouped_options, eval = FALSE--------------------------------------------
# count = 1
# array = c(0.1, 0.2)
# GetoptLong(
#     "--------", "Binary options:",
#     "verbose!", "Whether show messages",
#     "flag",     "a non-sense option",
# 
#     "-------", "Single-value options:",
#     "count=i",  paste("This is a count. This is a count. This is a count.",
#                       "This is a count.  This is a count. This is a count."),
#     "number=f", paste("This is a number. This is a number. This is a number.",
#                       "This is a number. This is a number. This is a number."),
# 
#     "--------", paste("Multiple-vlaue options: long text long text long text",
#                       " long text long text long text long text long text"),
#     "array=f@", paste("This is an array. This is an array. This is an array.",
#                       "This is an array. This is an array. This is an array."),
#     "hash=s%",  paste("This is a hash. This is a hash. This is a hash.",
#                       "This is a hash. This is a hash. This is a hash."),
# 
#     "-------", "Other options:"
# )

## ----echo = FALSE-------------------------------------------------------------
chunks <- knitr:::knit_code$get()
GetoptLong.options("__argv_str__" = "--help")
local({ eval(parse(text = chunks[["grouped_options"]])) })
GetoptLong.options("__argv_str__" = NULL)

## ----eval = FALSE-------------------------------------------------------------
# GetoptLong.options(help_style = "two-column")
# GetoptLong{
#     ...
# }

## ----echo = FALSE-------------------------------------------------------------
chunks <- knitr:::knit_code$get()
GetoptLong.options("__argv_str__" = "--help")
GetoptLong.options(help_style = "two-column")
local({ eval(parse(text = chunks[["grouped_options"]])) })
GetoptLong.options("__argv_str__" = NULL)
GetoptLong.options(help_style = "one-column")

## ----complex_template, eval = FALSE-------------------------------------------
# GetoptLong("
# This is a demonstration of using template as the option specification.
# 
# Usage: Rscript foo.R [options]
# 
# Binary options:
#   <verbose!> Whether show messages
#   <flag> A non-sense option
# 
# Single-value options:
#   <count=i> This is a count. This is a count.
#   <number=f> This is a number. This is a number.
# 
# Multiple-vlaue options:
#   <array=f@> This is an array. This is an array.
#   <hash=s%> This is a hash. This is a hash.
# 
# Questions, please contact your.name@email
# ", template_control = list(opt_width = c(verbose = 23, flag = 23,
#                                          count = 22, number = 22,
#                                          array = 30, hash = 30)
# ))

## ----echo = FALSE-------------------------------------------------------------
chunks <- knitr:::knit_code$get()
GetoptLong.options("__argv_str__" = "--help")
local({ eval(parse(text = chunks[["complex_template"]])) })
GetoptLong.options("__argv_str__" = NULL)

## ----template_multi_line, eval = FALSE----------------------------------------
# GetoptLong("
# Usage: Rscript foo.R [options]
# 
#   <count=i{2,}> This is a count. This is a count. This is a count.
#                 This is a count. This is a count.
#   <number=f> This is a number. This is a number. This is a number.
#              This is a number. This is a number.
# ")

## ----echo = FALSE-------------------------------------------------------------
chunks <- knitr:::knit_code$get()
GetoptLong.options("__argv_str__" = "--help")
local({ eval(parse(text = chunks[["template_multi_line"]])) })
GetoptLong.options("__argv_str__" = NULL)

## ----version, eval = FALSE----------------------------------------------------
# VERSION = "0.0.1"
# GetoptLong(
#     "tag=i", "...",
# )

## ----version2, eval = FALSE---------------------------------------------------
# VERSION = numeric_version("1.1-1")
# GetoptLong(
#     "tag=i", "...",
# )

## ----eval = FALSE-------------------------------------------------------------
# GetoptLong.options("config" = "bundling")
# GetoptLong.options("config" = c("no_ignore_case", "bundling"))

## ----eval = FALSE-------------------------------------------------------------
# source_script("foo.R", argv_str = "--cutoff 0.01 --input file=foo.txt --verbose")

## ----eval = TRUE--------------------------------------------------------------
sessionInfo()

## ----echo = FALSE, results = "asis"-------------------------------------------
get_os <- function(){
  sysinf <- Sys.info()
  if (!is.null(sysinf)){
  os <- sysinf['sysname']
  if (os == 'Darwin')
    os <- "osx"
  } else { ## mystery machine
    os <- .Platform$OS.type
    if (grepl("^darwin", R.version$os))
      os <- "osx"
    if (grepl("linux-gnu", R.version$os))
      os <- "linux"
  }
  tolower(os)
}

is.solaris = function() {
  os = get_os()
  !(os %in% c("windows", "unix", "linux", "osx"))
}

if(is.solaris()) {
  cat("**GetoptLong** is not supported on Solaris platform.\n")
} else {
  if(!is.solaris()) {
      invisible(knit("GetoptLong.Rmd2", "GetoptLong.md2"))
  }

  if(Sys.info()["user"] == "jokergoo") {
      invisible(file.copy("GetoptLong.md2", "/Users/jokergoo/project/GetoptLong/vignettes/GetoptLong.md2", overwrite = TRUE))
  }

  ln = readLines("GetoptLong.md2")
  cat(paste(ln, collapse = "\n"))
}

## ----echo = FALSE, message = FALSE--------------------------------------------
library(knitr)
knitr::opts_chunk$set(
    tidy  = FALSE,
    comment = NA,
    fig.align = "center")
library(GetoptLong)

## ----main, eval = FALSE-------------------------------------------------------
# library(GetoptLong)
# 
# subCommands(
# 	"sub1", "sub1.R",
# 	        "This is the description of sub command 1, which will be a long long long text.",
# 	"sub2", "sub2.R",
# 	        "This is the description of sub command 2, which will be a long long long text."
# )

## ----sub1, eval = FALSE-------------------------------------------------------
# library(GetoptLong)
# 
# GetoptLong("foo=i", "Set value for foo.")
# 
# qqcat("foo is @{foo}\n")

## ----sub2, eval = FALSE-------------------------------------------------------
# library(GetoptLong)
# 
# GetoptLong("bar=i", "Set value for bar")
# 
# qqcat("bar is @{bar}\n")

## ----echo = FALSE, eval = TRUE, results = "asis"------------------------------
chunks <- knitr:::knit_code$get()
writeLines(chunks[["main"]], con = "main.R")
writeLines(chunks[["sub1"]], con = "sub1.R")
writeLines(chunks[["sub2"]], con = "sub2.R")
cat("```\n")
cat(system("Rscript main.R", intern = TRUE), sep = "\n")
cat("```\n")

## ----echo = FALSE, eval = TRUE, results = "asis"------------------------------
cat("```\n")
cat(system("Rscript main.R sub1 --help", intern = TRUE), sep = "\n")
cat("```\n")

## ----echo = FALSE, eval = TRUE, results = "asis"------------------------------
cat("```\n")
cat(system("Rscript main.R sub1 --foo 10", intern = TRUE), sep = "\n")
cat("```\n")

## ----eval = FALSE-------------------------------------------------------------
# subCommands(
# 	"sub1", "path/sub1.R", "description 1",
# 	"sub2", "path/sub2.R", "description 2"
# )

## ----eval = FALSE-------------------------------------------------------------
# subCommands(
# 	"path/sub1.R", "description 1",
# 	"path/sub2.R", "description 2"
# )

## ----section, eval = FALSE----------------------------------------------------
# subCommands(
# 	"----", "----", "This is section1",
# 	"sub1", "sub1.R",
# 	      "This is the description of sub command 1, which will be a long long long text.",
# 
# 	"----", "----", "This is section2",
# 	"sub2", "sub2.R",
# 	      "This is the description of sub command 2, which will be a long long long text."
# )

## ----echo = FALSE, eval = TRUE, results = "asis"------------------------------
chunks <- knitr:::knit_code$get()
writeLines(c("library(GetoptLong)", chunks[["section"]]), con = "main.R")

cat("```\n")
cat(system("Rscript main.R", intern = TRUE), sep = "\n")
cat("```\n")

## ----head-foot, eval = FALSE--------------------------------------------------
# subCommands(
# 	help_head = "This is the head of the help message.",
# 
# 	"sub1", "sub1.R",
# 	        "This is the description of sub command 1, which will be a long long long text.",
# 	"sub2", "sub2.R",
# 	        "This is the description of sub command 2, which will be a long long long text.",
# 
# 	help_foot = "This is the foot of the help message."
# )

## ----echo = FALSE, eval = TRUE, results = "asis"------------------------------
chunks <- knitr:::knit_code$get()
writeLines(c("library(GetoptLong)", chunks[["head-foot"]]), con = "main.R")

cat("```\n")
cat(system("Rscript main.R", intern = TRUE), sep = "\n")
cat("```\n")

## ----template, eval = FALSE---------------------------------------------------
# subCommands(
# "This is the head of the help message.
# 
# Usage: Rscript main.R [command] [options]
# 
# Commands:
#   <sub1=sub1.R> This is the description of sub command 1, which will be a long long
#           long text.
#   <longlonglong=sub2.R> This is the description of sub command 2, which will be a long long
#           long text.
# 
# This is the foot of the help message.
# "
# )

## ----echo = FALSE, eval = TRUE, results = "asis"------------------------------
chunks <- knitr:::knit_code$get()
writeLines(c("library(GetoptLong)", chunks[["template"]]), con = "main.R")

cat("```\n")
cat(system("Rscript main.R", intern = TRUE), sep = "\n")
cat("```\n")

## ----echo = FALSE, results = "hide"-------------------------------------------
file.remove("main.R")
file.remove("sub1.R")
file.remove("sub2.R")

---
title: "Simple variable interpolation"
author: "Zuguang Gu (z.gu@dkfz.de)"
date: '`r Sys.Date()`'
output:
  html_document:
    fig_caption: true
    toc: true
    toc_depth: 2
    toc_float: true
vignette: >
  %\VignetteIndexEntry{Simple variable interpolation}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

---------------------------------------------------------------------

```{r, echo = FALSE, message = FALSE}
library(markdown)
options(markdown.HTML.options = c(options('markdown.HTML.options')[[1]], "toc"))

library(knitr)
knitr::opts_chunk$set(
    error = FALSE,
    tidy  = FALSE,
    message = FALSE,
    fig.align = "center")
options(markdown.HTML.stylesheet = "custom.css")

options(width = 100)
```

There are several ways to construct strings in **R** such as `paste()`.
However, when the string which is going to be constructed is too complex,
using `paste()` can be a pain. For example, we want to put some parameters as
title in a plot.

```{r}
region = c(1, 2)
value = 4
name = "name"
str = paste("region = (", region[1], ", ", region[2], "), value = ", value, 
            ", name = '", name, "'", sep = "")
cat(str)
```

As you can see, it is hard to read and very easy to make mistakes. (Syntax
highlighting may be helpful to match brackets, but it is still quite annoying
to see so many commas and quotes.)

In **Perl**, we always use variable interpolation to construct complex strings
in which variables are started with special marks (sigil), and variables will
be replaced with their real values. In this package, we aim to implement
variable interpolation in R. The idea is rather simple: use special marks to
identify variables and then replace with their values. The function here is
`qq()` which is named from the subroutine with the same name in **Perl** (It
stands for double quote). Using variable interpolation, above example can be
written as:

```{r}
library(GetoptLong)

str = qq("region = (@{region[1]}, @{region[2]}), value = @{value}, name = '@{name}'")
cat(str)
```

Or use the shortcut function `qqcat()`:

```{r}
qqcat("region = (@{region[1]}, @{region[2]}), value = @{value}, name = '@{name}'")
```

One feature of `qqcat()` is you can set a global prefix to the messages by `qq.options("cat_prefix")`, 
either a string or a function. If it is set as a function, the value will be generated at real time
by executing the function.

```{r}
qq.options("cat_prefix" = "[INFO] ")
qqcat("This is a message")

qq.options("cat_prefix" = function() format(Sys.time(), "[%Y-%m-%d %H:%M:%S] "))
qqcat("This is a message")
Sys.sleep(2)
qqcat("This is a message after 2 seconds")

qq.options("cat_prefix" = "")
qqcat("This is a message")
```

You can shut down all messages produced by `qqcat()` by `qq.options("cat_verbose" = FALSE)`. 

```{r}
qq.options("cat_prefix" = "[INFO] ", "cat_verbose" = FALSE)
qqcat("This is a message")
```

Also you can set a prefix which has local effect. 

```{r}
qq.options(RESET = TRUE)
qq.options("cat_prefix" = "[DEBUG] ")
qqcat("This is a message", cat_prefix = "[INFO] ")
qqcat("This is a message")
```

From version 1.1.2, `qq.options()` can work in a local mode in which
the copy of the options only work in a local chunk.

```{r}
qq.options("cat_prefix" = "[DEBUG] ")
qq.options(LOCAL = TRUE)
qq.options("cat_prefix" = "[INFO] ")
qqcat("This is the first message")
qqcat("This is the second message")
qq.options(LOCAL = FALSE)
qqcat("This is the third message")
```

Reset the options so that it does not affect example code in following part of the vignette.

```{r, eval = TRUE, results = 'hide', echo = TRUE}
qq.options(RESET = TRUE)
```

Not only simple scalars but also pieces of codes can be interpolated:

```{r}
n = 1
qqcat("There @{ifelse(n == 1, 'is', 'are')} @{n} dog@{ifelse(n == 1, '', 's')}.\n")
n = 2
qqcat("There @{ifelse(n == 1, 'is', 'are')} @{n} dog@{ifelse(n == 1, '', 's')}.\n")
```

If the text is too long, it can be wrapped into lines.

```{r}
qq.options("cat_strwrap" = TRUE)
qqcat("one, two, three, four, five, six, seven, eight, nine, ten, eleven, twelve, thirteen, fourteen, fifteen, sixteen, seventeen, eighteen, nineteen, twenty.")
```

There can be multiple templates:

```{r}
a = 1; b = 2; c = 3
txt = qq("command -a @{a}",
         "        -b @{b}",
         "        -c @{c}\n", sep = " \\\n")
cat(txt)
```

**NOTE:** Since `qq` as the function name is very easy to be used by other packages
(E.g., in **lattice**, there is a `qq()` function as well) and if so, you can enforce
`qq()` in your working environment as the function in **GetoptLong** by:

```{r, eval = FALSE}
qq = GetoptLong::qq
```

## Code patterns

In above exmaple, `@{}` is used to mark variables. Later, variable names will be extracted from these marks
and replaced with their real values.

The marking code pattern can be any type. But you should make sure it is easy to tell the difference
from other part in the string. You can set your code pattern as an argument in `qq()`. The default pattern
is `@\\{CODE\\}` because  we only permit `CODE`
to return simple vectors and `@` is a sigil representing array in **Perl**.

In following example, the code pattern is `#{}`.

```{r}
x = 1
qqcat("x = #{x}", code.pattern = "#\\{CODE\\}")
```

Or set in `qq.options()` as a global setting:

```{r, eval = FALSE}
qq.options("code.pattern" = "#\\{CODE\\}")
```

As you can guess, in `@\\{CODE\\}`, `CODE` will be replaced with `.*?` to construct a regular
expression and to match variable names in the string. So if your `code.pattern` contains special characters,
make sure to escape them. Some candidate `code.pattern` are:

```{r, eval = FALSE}
code.pattern = "@\\{CODE\\}"    # default style
code.pattern = "@\\[CODE\\]"
code.pattern = "@\\(CODE\\)"
code.pattern = "%\\{CODE\\}"
code.pattern = "%\\[CODE\\]"
code.pattern = "%\\(CODE\\)"
code.pattern = "\\$\\{CODE\\}"
code.pattern = "\\$\\[CODE\\]"
code.pattern = "\\$\\(CODE\\)"
code.pattern = "#\\{CODE\\}"
code.pattern = "#\\[CODE\\]"
code.pattern = "#\\(CODE\\)"
code.pattern = "\\[%CODE%\\]"  # Template Toolkit (Perl module) style :)
```

Since we just replace `CODE` to `.*?`, the function will only match to the first right parentheses/brackets.
(In **Perl**, I always use recursive regular expression to extract such pairing parentheses. But in **R**, it seems difficult.)
So, for example, if you are using `@\\[CODE\\]` and your string is `"@[a[1]]"`, it will fail to
extract the correct variable name while only extracts `a[1`, finally it generates an error when executing `a[1`. In such condition, you should use other pattern styles
that do not contain `[]`.

Finally, I suggest a more safe code pattern style that you do not need to worry about parentheses stuff:

```{r, eval = FALSE}
code.pattern = "`CODE`"
```

## Where to look for variables

It will first look up in the envoking environment, then through searching path. Users can also pass values of variables
as a list like:

```{r}
x = 1
y = 2
qqcat("x = @{x}, y = @{y}", envir = list(x = "a", y = "b"))
```

If variables are passed through list, `qq()` only looks up in the specified list.

## Variables should only return vectors

`qq()` only allows variables to return vectors. The whole string will be interpolated repeatedly according to longest vectors,
and finally concatenated into a single long string.

```{r}
x = 1:6
qqcat("@{x} is an @{ifelse(x %% 2, 'odd', 'even')} number.\n")


y = c("a", "b")
z = c("A", "B", "C", "D", "E")
qqcat("@{x}, @{y}, @{z}\n")
```

This feature is especially useful if you want to generate a report such as formatted in a HTML table:

```{r}
name = letters[1:4]
value = 1:4
qqcat("<tr><td>@{name}</td><td>@{value}</td><tr>\n")
```

The returned value can also be a vector while not collapsed into one string:

```{r}
str = qq("@{x}, @{y}, @{z}", collapse = FALSE)
length(str)
str
```


## Session info

```{r}
sessionInfo()
```

---
title: "Sub-commands"
author: "Zuguang Gu (z.gu@dkfz.de)"
date: '`r Sys.Date()`'
output:
  html_document:
    fig_caption: true
    toc: true
    toc_depth: 3
    toc_float: true
vignette: >
  %\VignetteIndexEntry{Sub-commands}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

---------------------------------------------------------------------

```{r, echo = FALSE, message = FALSE}
library(knitr)
knitr::opts_chunk$set(
    tidy  = FALSE,
    comment = NA,
    fig.align = "center")
library(GetoptLong)
```


## A quick example

The following code gives you a quick example of how the sub commands are set. In the function `subCommands()`, the input is in form
of a vector, where the elements are grouped by every three. The three elements in every group are 

1. name of the sub command,
2. path of the corresponding R script,
3. description of the corresponding sub command.

The following code is in the script called `main.R` which contains dispatch of the sub commands.

```{r main, eval = FALSE}
library(GetoptLong)

subCommands(
	"sub1", "sub1.R", 
	        "This is the description of sub command 1, which will be a long long long text.",
	"sub2", "sub2.R",
	        "This is the description of sub command 2, which will be a long long long text."
)
```

Code in `sub1.R`:

```{r sub1, eval = FALSE}
library(GetoptLong)

GetoptLong("foo=i", "Set value for foo.")

qqcat("foo is @{foo}\n")
```

And code in `sub2.R`:

```{r sub2, eval = FALSE}
library(GetoptLong)

GetoptLong("bar=i", "Set value for bar")

qqcat("bar is @{bar}\n")
```

Calling `main.R` with no argument prints the list of sub commands it supports:

```
Rscript main.R
```

```{r, echo = FALSE, eval = TRUE, results = "asis"}
chunks <- knitr:::knit_code$get()
writeLines(chunks[["main"]], con = "main.R")
writeLines(chunks[["sub1"]], con = "sub1.R")
writeLines(chunks[["sub2"]], con = "sub2.R")
cat("```\n")
cat(system("Rscript main.R", intern = TRUE), sep = "\n")
cat("```\n")
```

When sub command is called, the corresponding R script is invoked. Here all command-line arguments after the sub command `sub1` go
to the correspond R script `sub1.R`.

```
Rscript main.R sub1 --help
```

```{r, echo = FALSE, eval = TRUE, results = "asis"}
cat("```\n")
cat(system("Rscript main.R sub1 --help", intern = TRUE), sep = "\n")
cat("```\n")
```

Internally, it actually executes `Rscript sub1.R --help`.

Options in `sub1.R` can be directly set after the sub command:

```
Rscript main.R sub1 --foo 10
```

```{r, echo = FALSE, eval = TRUE, results = "asis"}
cat("```\n")
cat(system("Rscript main.R sub1 --foo 10", intern = TRUE), sep = "\n")
cat("```\n")
```


## The specification

The specification for sub commands can be set as a vector. The length should be multiples of either 2 or 3.

In the following code, the input of `subCommands()` will be internally put into a three-column matrix filled by rows,
where the first column contains sub commands, the second column contains paths of corresponding R scripts, and the third
column contains descriptions for sub commands.

```{r, eval = FALSE}
subCommands(
	"sub1", "path/sub1.R", "description 1",
	"sub2", "path/sub2.R", "description 2"
)
```

Or in another way:

```{r, eval = FALSE}
subCommands(
	"path/sub1.R", "description 1",
	"path/sub2.R", "description 2"
)
```

In this case, the sub commands are taken from the basename of the R script, also removing the suffix names (`.R`).

Whether the arguments are grouped by every 2 elements or 3 elements is automatically detected in `subCommands()`.

## Commands in sections

Sometimes we want to group commands and put them into sections. This can be done by adding a section tag `"-----"` as shown in the following example.

```{r section, eval = FALSE}
subCommands(
	"----", "----", "This is section1",
	"sub1", "sub1.R", 
	      "This is the description of sub command 1, which will be a long long long text.",

	"----", "----", "This is section2",
	"sub2", "sub2.R",
	      "This is the description of sub command 2, which will be a long long long text."
)
```


```{r, echo = FALSE, eval = TRUE, results = "asis"}
chunks <- knitr:::knit_code$get()
writeLines(c("library(GetoptLong)", chunks[["section"]]), con = "main.R")

cat("```\n")
cat(system("Rscript main.R", intern = TRUE), sep = "\n")
cat("```\n")
```

## Setting help head and foot

`help_head` adds text before the help message and `help_foot` adds text after the help message.


```{r head-foot, eval = FALSE}
subCommands(
	help_head = "This is the head of the help message.",

	"sub1", "sub1.R", 
	        "This is the description of sub command 1, which will be a long long long text.",
	"sub2", "sub2.R",
	        "This is the description of sub command 2, which will be a long long long text.",

	help_foot = "This is the foot of the help message."
)
```

```{r, echo = FALSE, eval = TRUE, results = "asis"}
chunks <- knitr:::knit_code$get()
writeLines(c("library(GetoptLong)", chunks[["head-foot"]]), con = "main.R")

cat("```\n")
cat(system("Rscript main.R", intern = TRUE), sep = "\n")
cat("```\n")
```


## Setting with a template

`subCommands()` can be set as a single long text which is a template of the help message. Commands are wrapped
in `<>`. The value can be a pair of `<command=script>` or just `<script>`. If it is in a form of `<script>`, the basename
without the file suffix is used as the command.

```{r template, eval = FALSE}
subCommands(
"This is the head of the help message.

Usage: Rscript main.R [command] [options]

Commands:
  <sub1=sub1.R> This is the description of sub command 1, which will be a long long
          long text.
  <longlonglong=sub2.R> This is the description of sub command 2, which will be a long long
          long text.

This is the foot of the help message.
"
)
```

```{r, echo = FALSE, eval = TRUE, results = "asis"}
chunks <- knitr:::knit_code$get()
writeLines(c("library(GetoptLong)", chunks[["template"]]), con = "main.R")

cat("```\n")
cat(system("Rscript main.R", intern = TRUE), sep = "\n")
cat("```\n")
```

```{r, echo = FALSE, results = "hide"}
file.remove("main.R")
file.remove("sub1.R")
file.remove("sub2.R")
```


<script>
var elements = document.getElementsByTagName("pre");
for(var i = 0; i < elements.length; i ++ ) {
    if(!elements[i].hasAttribute("class")) {
        code = elements[i].children[0];
        code.style.color = "white";
        code.style.background = "rgb(38,38,38)";
        elements[i].style.background = "hsl(70, 0%, 15%)";
    }
}
</script>

---
title: "Parsing command-line arguments by Getopt::Long"
author: "Zuguang Gu (z.gu@dkfz.de)"
date: '`r Sys.Date()`'
output:
  html_document:
    fig_caption: true
    toc: true
    toc_depth: 3
    toc_float: true
vignette: >
  %\VignetteIndexEntry{Parsing command-line arguments by Getopt::Long}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

---------------------------------------------------------------------

```{r, echo = FALSE, message = FALSE}
library(knitr)
knitr::opts_chunk$set(
    error = FALSE,
    tidy  = FALSE,
    message = FALSE,
    comment = NA,
    fig.align = "center")
library(GetoptLong)
```


```{r, echo = FALSE, results = "asis"}
get_os <- function(){
  sysinf <- Sys.info()
  if (!is.null(sysinf)){
  os <- sysinf['sysname']
  if (os == 'Darwin')
    os <- "osx"
  } else { ## mystery machine
    os <- .Platform$OS.type
    if (grepl("^darwin", R.version$os))
      os <- "osx"
    if (grepl("linux-gnu", R.version$os))
      os <- "linux"
  }
  tolower(os)
}

is.solaris = function() {
  os = get_os()
  !(os %in% c("windows", "unix", "linux", "osx"))
}

if(is.solaris()) {
  cat("**GetoptLong** is not supported on Solaris platform.\n")
} else {
  if(!is.solaris()) {
      invisible(knit("GetoptLong.Rmd2", "GetoptLong.md2"))
  }

  if(Sys.info()["user"] == "jokergoo") {
      invisible(file.copy("GetoptLong.md2", "/Users/jokergoo/project/GetoptLong/vignettes/GetoptLong.md2", overwrite = TRUE))
  }

  ln = readLines("GetoptLong.md2")
  cat(paste(ln, collapse = "\n"))
}
```

\name{subCommands}
\alias{subCommands}
\title{
Setting sub commands
}
\description{
Setting sub commands
}
\usage{
subCommands(..., help_head = NULL, help_foot = NULL, argv_str = NULL)
}
\arguments{

  \item{...}{Specification of commands. See section Details.}
  \item{help_head}{Head of the help message when invoking \code{Rscript foo.R}.}
  \item{help_foot}{Foot of the help message when invoking \code{Rscript foo.R}.}
  \item{argv_str}{A string that contains command-line arguments. It is only for testing purpose.}

}
\details{
The format of input can be one of the following:

1. A matrix with two columns. Then the first column contains paths of the scripts and the second column contains the description of the subcommand. The basenames of path in the first column
   by removing the suffix are taken as the sub commands.
2. A matrix with three columns. The the first column contains the sub commands, the second column contains corresponding script paths and the third column contains descriptions of the sub commands.
3. A vector with length as multiples of 2. In this case, every two elements are grouped and concatenated into a matrix by rows. Then it follows the rule 1.
4. A vector with length as multiples of 3. In this case, every three elements are grouped and concatenated into a matrix by rows. Then it follows the rule 2.
}
\examples{
# There is no example
NULL

}

\name{GetoptLong.options}
\alias{GetoptLong.options}
\title{
Global options for GetoptLong()
}
\description{
Global options for GetoptLong()
}
\usage{
GetoptLong.options(..., RESET = FALSE, READ.ONLY = NULL, LOCAL = FALSE, ADD = FALSE)
}
\arguments{

  \item{...}{Options, see 'Details' section.}
  \item{RESET}{Whether to reset options to their default values.}
  \item{READ.ONLY}{Whether to only return read-only options.}
  \item{LOCAL}{Whether to switch local mode.}
  \item{ADD}{Whether to add new options.}

}
\details{
Supported global options are following:

\describe{
  \item{\code{config}}{Configuration of \code{Getopt::Long}, check \url{https://perldoc.pl/Getopt::Long#Configuring-Getopt::Long} .}
  \item{\code{template_tag}}{The tag for identifying specifications in the template. The format should be in \code{left_tag CODE right_tag}.}
  \item{\code{help_style}}{The style of the help message. }
}

\code{GetoptLong.options(...)} should be put before calling \code{\link{GetoptLong}} function.
}
\author{
Zuguang Gu <z.gu@dkfz.de>
}
\examples{
# There is no example
NULL

}

\name{qqcat}
\alias{qqcat}
\title{
Print a string which has been intepolated with variables
}
\description{
Print a string which has been intepolated with variables
}
\usage{
qqcat(..., envir = parent.frame(), code.pattern = NULL, file = "",
    sep = " ", fill = FALSE, labels = NULL, append = FALSE, cat_prefix = NULL,
    strwrap = qq.options("cat_strwrap"), strwrap_param = list(), sep2 = "")
}
\arguments{

  \item{...}{text string in which variables are marked with certain rules}
  \item{envir}{environment where to look for those variables}
  \item{code.pattern}{pattern of marks for the variables}
  \item{file}{pass to \code{\link[base]{cat}}}
  \item{sep}{pass to \code{\link[base]{cat}}}
  \item{fill}{pass to \code{\link[base]{cat}}}
  \item{labels}{pass to \code{\link[base]{cat}}}
  \item{append}{pass to \code{\link[base]{cat}}}
  \item{cat_prefix}{prefix string. It is prior than \code{qq.options(cat_prefix)}.}
  \item{strwrap}{whether call \code{\link[base]{strwrap}} to wrap the string}
  \item{strwrap_param}{parameters sent to \code{\link[base]{strwrap}}, must be a list}
  \item{sep2}{Separation character when there are multiple templates.}

}
\details{
This function is a shortcut of

  \preformatted{
    cat(qq(text, envir, code.pattern), ...)  }

Additionally, you can add global prefix:

  \preformatted{
    qq.options("cat_prefix" = "[INFO] ")
    qq.options("cat_prefix" = function(x) format(Sys.time(), "[\%Y-\%m-\%d \%H:\%M:\%S] "))
    qq.options("cat_prefix" = NULL)  }

You can also add local prefix by specifying \code{cat_prefix} in \code{\link{qqcat}}.

  \preformatted{
    qqcat(text, cat_prefix = "[INFO] ")  }

Please refer to \code{\link{qq}} to find more details.
}
\author{
Zuguang Gu <z.gu@dkfz.de>
}
\examples{
a = 1
b = "text"
qqcat("a = @{a}, b = '@{b}'\n")
qqcat("a = `a`, b = '`b`'\n", code.pattern = "`CODE`")

qq.options("cat_prefix" = function(x) format(Sys.time(), "[\%Y-\%m-\%d \%H:\%M:\%S] "))
qqcat("a = @{a}, b = '@{b}'\n")
Sys.sleep(2)
qqcat("a = @{a}, b = '@{b}'\n")
qq.options(RESET = TRUE)
}

\name{GetoptLong}
\alias{GetoptLong}
\title{
Wrapper of the Perl module \code{Getopt::Long} in R
}
\description{
Wrapper of the Perl module \code{Getopt::Long} in R
}
\usage{
GetoptLong(..., help_head = NULL, help_foot = NULL, envir = parent.frame(),
    argv_str = NULL, template_control = list(),
    help_style = GetoptLong.options$help_style)
}
\arguments{

  \item{...}{Specification of options. The value can be a two-column matrix, a vector with even number of elements  or a text template. See the vignette for detailed explanation.}
  \item{help_head}{Head of the help message when invoking \code{Rscript foo.R --help}.}
  \item{help_foot}{Foot of the help message when invoking \code{Rscript foo.R --help}.}
  \item{envir}{User's enrivonment where \code{\link{GetoptLong}} looks for default values and exports variables.}
  \item{argv_str}{A string that contains command-line arguments. It is only for testing purpose.}
  \item{template_control}{A list of parameters for controlling when the specification is a template.}
  \item{help_style}{The style of the help messages. Value should be either "one-column" or "two-column".}

}
\details{
Following shows a simple example. Put following code at the beginning of your script (e.g. \code{foo.R}):

  \preformatted{
    library(GetoptLong)

    cutoff = 0.05
    GetoptLong(
        "number=i", "Number of items.",
        "cutoff=f", "Cutoff for filtering results.",
        "verbose",  "Print message."
    )  }

Then you can call the script from command line either by:

  \preformatted{
    Rscript foo.R --number 4 --cutoff 0.01 --verbose
    Rscript foo.R --number 4 --cutoff=0.01 --verbose
    Rscript foo.R -n 4 -c 0.01 -v
    Rscript foo.R -n 4 --verbose  }

In this example, \code{number} is a mandatory option and it should only be in
integer mode. \code{cutoff} is optional and it already has a default value 0.05.
\code{verbose} is a logical option. If parsing is successful, two variables \code{number}
and \code{verbose} will be imported into the working environment with the specified
values. Value for \code{cutoff} will be updated if it is specified in command-line.

For advanced use of this function, please go to the vignette.
}
\author{
Zuguang Gu <z.gu@dkfz.de>
}
\examples{
# There is no example
NULL

}

\name{source_script}
\alias{source_script}
\title{
Source the R script with command-line arguments
}
\description{
Source the R script with command-line arguments
}
\usage{
source_script(file, ..., argv_str = NULL)
}
\arguments{

  \item{file}{The R script}
  \item{...}{Pass to \code{\link[base]{source}}.}
  \item{argv_str}{The command-line arguments.}

}
\examples{
# There is no example
NULL

}

\name{get_scriptdir}
\alias{get_scriptdir}
\title{
Directory of current script
}
\description{
Directory of current script
}
\usage{
get_scriptdir()
}
\value{
If the R script is not run from the command-line, it returns \code{NULL}.
}
\author{
Zuguang Gu <z.gu@dkfz.de>
}
\examples{
# There is no example
NULL

}

\name{GetOptions}
\alias{GetOptions}
\title{
Wrapper of the Perl module \code{Getopt::Long} in R
}
\description{
Wrapper of the Perl module \code{Getopt::Long} in R
}
\usage{
GetOptions(..., envir = parent.frame())
}
\arguments{

  \item{...}{Pass to \code{\link{GetoptLong}}.}
  \item{envir}{User's enrivonment where \code{\link{GetoptLong}} looks for default values and exports variables.}

}
\details{
This function is the same as \code{\link{GetoptLong}}. It is just to make it consistent as the \code{GetOptions()} 
subroutine in \code{Getopt::Long} module in Perl.
}
\author{
Zuguang Gu <z.gu@dkfz.de>
}
\examples{
# There is no example
NULL

}

\name{qq.options}
\alias{qq.options}
\title{
Global options for qq() related functions
}
\description{
Global options for qq() related functions
}
\usage{
qq.options(..., RESET = FALSE, READ.ONLY = NULL, LOCAL = FALSE, ADD = FALSE)
}
\arguments{

  \item{...}{Options, see 'Details' section.}
  \item{RESET}{Whether to reset options to their default values.}
  \item{READ.ONLY}{Whether to only return read-only options.}
  \item{LOCAL}{Whether to switch local mode.}
  \item{ADD}{Whether to add new options.}

}
\details{
Supported options are following:

\describe{
  \item{\code{cat_prefix}}{prefix of the string which is printed by \code{\link{qqcat}}}
  \item{\code{cat_verbose}}{whether to print text by \code{\link{qqcat}}}
  \item{\code{cat_strwrap}}{whether call \code{\link[base]{strwrap}} to wrap the string}
  \item{\code{code.pattern}}{code pattern for variable interpolation}
}
}
\author{
Zuguang Gu <z.gu@dkfz.de>
}
\examples{
a = 1
qq.options(cat_prefix = "[INFO] ")
qqcat("a = @{a}\n")
qq.options(cat_verbose = FALSE)
qqcat("a = @{a}\n")
qq.options(RESET = TRUE)
qq.options(code.pattern = "`CODE`")
qqcat("a = `a`\n")
qq.options(RESET = TRUE)
}
